PrestoAnalytics = {
  analyticsEnabled: false,
  
  initialize: function(trackingId){
    PrestoAnalytics.analyticsEnabled = true;
    window.analytics.startTrackerWithId(trackingId);
    if(Presto.merchant.demoGraphicEnabled){
      window.analytics.enableAdvertisingIdCollection(true, function() {
        console.log("success callback for enableAdvertisingIdCollection");
      }, function() {
      console.log("error callback for enableAdvertisingIdCollection");
      });
    }
  },
  trackView: function(viewName) {
    if(PrestoAnalytics.analyticsEnabled){
        window.analytics.trackView(viewName);
    }
  },
  
  trackEvent: function(category, action, label, value){
    if(PrestoAnalytics.analyticsEnabled){
      window.analytics.trackEvent(category, action, label=null, value=null);
    }
  },
  
  trackException: function(description, fatal){
    if(PrestoAnalytics.analyticsEnabled){
      window.analytics.trackException(description, fatal);
    }
  },
  
  trackTiming: function(category, interval, variable, label) {
    if(PrestoAnalytics.analyticsEnabled){
      window.analytics.trackTiming(category, interval, variable, label);
    }
  },
  
  trackOrderPlaced: function(order){
    if(PrestoAnalytics.analyticsEnabled){
      PrestoAnalytics.addTransaction(order.id, Presto.merchant.name, order.billAmount, order.tax, order.shipping, "INR");
      $(order.lineItems).each(function(i, item){
        PrestoAnalytics.addTransactionItem(order.id, item.name, item.itemId, item.categoryId, item.totalPrice, item.quantity, "INR");
      });
    }
  },
  
  addTransaction: function(id, affiliation, revenue, tax, shipping, currency){
    if(PrestoAnalytics.analyticsEnabled){
      window.analytics.addTransaction(id, affiliation, revenue, tax, shipping, currency);
    }
  },
  
  addTransactionItem: function(id, item_name, sku, category, price, quantity, currency){
    if(PrestoAnalytics.analyticsEnabled){
      window.analytics.addTransactionItem(id, item_name, sku, category, price, quantity, currency);
    }
  },
  
  addCustomDimension: function(key, value, success, error){
    if(PrestoAnalytics.analyticsEnabled){
      window.analytics.addCustomDimension(key, value, success, error);
    }
  },
  
  setUserId: function(userId){
    if(PrestoAnalytics.analyticsEnabled){
      window.analytics.setUserId(userId);
    }
  }
  
}