Handlebars.registerHelper('withWindow', function(options) {
  return options.fn(window);
});

Handlebars.registerHelper('withPresto', function(options) {
  return options.fn(Presto);
});

Handlebars.registerHelper('prestoInc', function(value, options) {
  return value + 1;
});

Handlebars.registerHelper('prestoMapUrl', function(outlet, options) {
  var location = outlet.address.location;
  var name = outlet.name;
  if (device.platform == 'iOS') {
    var scheme = 'maps';
    if (Presto.env.ios.googleMapsInstalled) {
      return 'comgooglemaps://?q=' + location[0] + ',' + location[1] + '&zoom=15&center=' + location[0] + ',' + location[1]; 
    } else {
      return 'maps:q=' + location[0] + ',' + location[1] + '&z=17';
    }
  } else {
    return 'geo:' + location[0] + ',' + location[1] + '?q=' + location[0] + ',' + location[1] + '(' + name + ')&z=15';
  }
});

Handlebars.registerHelper('itemOrItems', function(options) {
  return Presto.utils.itemOrItemsString();
});

Handlebars.registerHelper('unless_blank', function(item, block) {
  return (item && item.replace(/\s/g,"").length) ? block.fn(this) : block.inverse(this);
});

Presto.utils = {
  hashifyArray: function(array, hashKeyName) {
    var hash = {};
    if (typeof(array) != 'undefined' && array.length > 0) {
      for(var i in array) {
        hash[array[i][hashKeyName]] = array[i];
      }
    }
    return hash;
  },
  
  concatHashKeys: function(hash, keys) {
    var str = '';
    for (var i in keys) {
      var key = keys[i];
      if (hash[key]) {
        str+= hash[key].toString() + ', ';
      }
    }
    
    str = str.replace(/(, )*$/, '');
    return str;
  },
  
  itemOrItemsString: function() {
    if (Presto.user.order.noOfItems == 1) {
      return "Item";
    } else {
      return "Items";
    }
  }
};