/*
 * Copyright 2014 Presto Inc. All rights reserved.
 */
var pushNotification;
var Presto = {
  
  app: {
    host: "api.presto-apps.com",
    name: "MK Dabbawala",
    id: "com.presto.restaurant.mkdabbawala",
    db_id: "552a686d777331186e8b0100",
    authTokenUrl: "http://api.presto-apps.com/auth_token.json",
    authToken: null,
    pushId: null,
    deviceId: null,
    currentPage: null,
    backbuttonWiredUp: null,
    backTemplateName: null,
    backTemplateData: null,
    notificationBgColor: "#E7512A",
    razorPayThemeColor: "",
    razorApiKey: "",
    merchantLogoFilePath: "",
    razor_pay: "",
    currency: "",
    defaultOrder: {
      outletId: null,
      noOfItems: 0,
      totalPrice: 0,
      basePrice: 0,
      tax: 0,
      serviceTax: 0,
      vatAmount: 0,
      billAmount: 0,
      packagingAmount: 0,
      deliveryCharges: 0,
      lineItems: {}
    }
  },
  
  env: {
    ios: {
      googleMapsInstalled: false
    }
  },
  
  merchant: {
    id: "552a6652777331186a500100",
    app_id: "552a686d777331186e8b0100",
    name: "MK Dabbawala",
    description: "",
    phone: "+919886033322",
    outletsUrl: "http://api.presto-apps.com/outlets.json?merchant_id=552a6652777331186a500100",
    outlets: [],
    outletsHash: {},
    outletsSorted: false,
    sortedOutlets: [],
    cityBasedOutlets: {},
    outletCities: [],
    outletsFetched: false,
    outletsFetchTime: null,
    nearestOutlet: null,
    nearestOutletFetchTime: null,
    deliveryTimePromise: "Your order will be delivered within 45 to 55 minutes.",
    deliveryCharges: "30",
    extraDeliveryCharges: "",
    enable_cart: "true",
    catalog: [],
    outletsCatalog: [],
    catalogFetched: false,
    catalogFetchTime: null,
    show_menu_on_home: "true",
    show_categories_in_bottom_bar: "true",
    prepaid_card_enabled: "",
    prepaid_card_api: "",
    fetchCatalogThrobber: "",
    fb_share_link: "",
    setPasswordMessage: "",
    clearCartToCategory: "true",
    giftMessageEnabled: "true",
    commonCatalogFilter: "catalog_v2",
    commonCatalogFilterEnabled: "true",
    needUserDetailsInOrderSummary: "true",
    hasCategoryBar: "true",
    allowPreviousDate : "",
    inventory_enabled : "",
    categoryBarWithoutImages: "true",
    hideRemoveControlOnEmptyCount: "",
    inferred_home_template: "",
    minimumOrderValueMessage: "",
    minimumOrderValue: "",
    has_menu_in_category_page: "",
    maximum_date_for_delivery: "",
    minimum_date_for_delivery: "",
    delivery_for_certain_date: "",
    message: "Order and get Rs.50 Off. Use my referral code – REF_CODE",
    subject: "Signup to get your free lunch",
    link: "http://smarturl.it/mkdabba",
    referralPageTitle: "Get Rs.50 Off",
    cutOffTime: {
      startHours: "",
      endHours: "",
      startMinutes: "",
      endMinutes: "",
    }
  },
  
  user: {
    currentLocation: null,
    lastLocationFetchTime: null,
    loginStatus: false,
    order: null,
    existing_orders: {},
    chosenTimeSlot: null,
    chosenOutlet: null
  },
  
  chosenServices: [],
  
  // Application Constructor
  initialize: function() {
    
      Presto.merchant.hasCommonCatalog = true;
    
    
    
    
    
      Presto.merchant.has_home_page_offer = "true";
      Presto.merchant.home_page_offer_url = "/apps/552a686d777331186e8b0100/home_page_offer.json";
    
    
  
    
      Presto.app.gcm_sender_id = "716909787297";
    
  
    
      Presto.app.ga_tracking_id = "UA-59413304-3";
    
    
    
      Presto.app.payment_enabled = "true";
    
    
    
    
    
    
    
      Presto.merchant.checkoutButtonTitle = "Get My Dabba";
    
    
    
      Presto.merchant.homeCheckoutButtonTitle = "Next";
    
    
    
      Presto.merchant.homeTitle = "Aaj ka Dabba";
    
    
    
    
    
      Presto.merchant.email = "vrinda@mastkalandar.com";
    
    
    
      Presto.merchant.chooseNearestOutlet = "true";
    
  
    
    
    
      Presto.merchant.demoGraphicEnabled = true;
    
  
    
  
    
      Presto.app.discount_coupon_enabled = "true"
    
    
    this.bindEvents();
  },
  
  bindEvents: function() {
    document.addEventListener('deviceready', this.onDeviceReady, false);
    $(document).ready(function() {
      console.debug("Registering slidebars handler");
      //$.slidebars();
      Presto.slidebars = new Snap({
        element: document.getElementById('sb-site'),
        disable: 'right'
      });
    });
  },
  
  onDeviceReady: function() {
    try {
      if(Presto.app.ga_tracking_id){
        PrestoAnalytics.initialize(Presto.app.ga_tracking_id);
        PrestoAnalytics.trackEvent('init', 'deviceReady');
      }
      Presto.slidebars = new Snap({
        element: document.getElementById('sb-site'),
        hyperextensible: false,
        disable: 'right',
        flickThreshold: 1,
        resistance: 0.99,
        slideIntent: 40,
        minDragDistance: 1,
        transitionSpeed: 0.1,
        maxPosition: 266
      });
    
      Presto.resetOrder();
      Presto.populateSidebarView();
      Presto.addGlobalClickHandlers();
    
    if(Presto.merchant.fixed_time_ordering){
      
      $.get("http://" + Presto.app.host + Presto.merchant.transaction_check_api, function(checkData, status, xhr) {
        if(checkData.can && (checkData.can == true || checkData.can == "true")){
            if(Presto.merchant.show_menu_on_home && Presto.merchant.show_menu_on_home == "true"){
              Presto.fetchAndShowCatalogForMerchant("category_list.hbs", Presto.merchant.id);
            }else {
              Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
            }
      Presto.noTransaction = false;
      }else{
        Presto.noTransaction = true;
      Presto.noTransactionMessage = checData.message;
        var no_transaction_data = {
        "message": checkData.message,
        "merchant": Presto.merchant
      }
        Presto.showTemplate('www/templates/no_transaction.hbs', no_transaction_data);
      }
      }).fail(function(xhr, status, error) {
          if(Presto.merchant.show_menu_on_home && Presto.merchant.show_menu_on_home == "true"){
            Presto.fetchAndShowCatalogForMerchant("category_list.hbs", Presto.merchant.id);
          }else {
            Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
          }
      });
    }else{
        if(Presto.merchant.show_menu_on_home && Presto.merchant.show_menu_on_home == "true"){
          if(Presto.merchant.hasCityBasedCatalog){
            $.blockUI(Presto.getThrobberData("Fetching the catalogue"));
            Presto.fetchNearestOutlet(function(nearestOutlet, sorted) {
              //$.unblockUI();
              if(Presto.merchant.show_categories_in_bottom_bar){
                Presto.fetchCatalogAndShowFirstCategoryForOutlet("category.hbs", Presto.merchant.nearestOutlet.id);
                Presto.populateSidebarView();
              }else {
                Presto.fetchAndShowCatalogForOutlet("category_list.hbs", Presto.merchant.nearestOutlet.id);
              }              
            }, function(xhr, status, reason){
              $.unblockUI();
            });
          }else {
            if (Presto.merchant.show_categories_in_bottom_bar) {
              Presto.fetchCatalogAndShowFirstCategoryForOutlet("category.hbs", null);
              Presto.populateSidebarView();
            } else {
              Presto.fetchAndShowCatalogForMerchant("category_list.hbs", Presto.merchant.id);
            } 
          }          
        }else {
            Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
        }
    }
      
      
      Presto.fetchAndShowHomePageOffer();
      
      Presto.fetchAndUpdateAuthToken();
      Presto.fetchAndUpdateUserData();
      if(Presto.merchant.show_menu_on_home && Presto.merchant.show_menu_on_home == "true"){
      Presto.fetchAndUpdateOutletsData();
      }else{
        Presto.fetchAndUpdateOutletsData();
      }      
      if(Presto.app.gcm_sender_id){
        Presto.setupPush();
      }
    
    if(Presto.app.dynamic_delivery_location_enabled){
      Presto.fetchDynamicDeliveryLocation();
    }
      
    Presto.scanEnvironment();
      
    Presto.deviceLocationEnabled = true; //As a backup. In case plugin could not be initialized, lets still try the cordova route. 
    if (window.cordova) {
      cordova.plugins.diagnostic.isLocationEnabled(
          function(e) {
              if (e) {
                  Presto.deviceLocationEnabled = true;
        }
              else {
                  Presto.deviceLocationEnabled = false;
              }
          },
          function(e) {
        //Ignore.
          }
        );
      }
    
      navigator.splashscreen.hide();
    } catch(ex) {
      navigator.splashscreen.hide();
      console.error("caught exception : " + ex.message);
    }
  },
  
  fetchDynamicDeliveryLocation: function(){
    var dynamicLocationUrl = "http://" + Presto.app.host + "/apps/" + Presto.merchant.app_id + "/delivery_area.json";
    $.get(dynamicLocationUrl, function(locationData, status, xhr) {
      Presto.merchant.delivery_location = locationData.message;
    }).fail(function(xhr, status, error) {
      // XXX : TODO : What should be done here?
    });
  },
  
  setupPush: function(){
    console.log("setupPush called");
    var androidData = {
      "senderID": Presto.app.gcm_sender_id,
      "sound":true,
      "vibration":true,
      "forceShow":true,
      "icon": "push_icon"
    }
    
    if (Presto.app.notificationBgColor) {
      androidData['iconColor'] = Presto.app.notificationBgColor;
    }
    
    pushNotification = PushNotification.init({
        "android": androidData,
        "ios": {"alert": "true", "badge": "true", "sound": "true", "clearBadge": "true"}, 
        "windows": {} 
    });
    
    pushNotification.on('registration', function(data) {
      console.log("regID = " + data.registrationId);
      Presto.registerDevice(data.registrationId);
    });
    
    pushNotification.on('notification', function(data) {
      console.log("notification event data=" + JSON.stringify(data));
      if (!Presto.app.currentPage || null == Presto.app.currentPage || "" == Presto.app.currentPage) {
        Presto.showTemplate('www/templates/home.hbs');
      }
      pushNotification.finish(function () {
          console.log('finish successfully called');
      });
      var deviceId = Presto.app.deviceId;
      if(!deviceId || deviceId == ""){
        deviceId = window.localStorage.getItem("Presto.app.deviceId");
      }
      
      if (null != data.additionalData && undefined != data.additionalData) {
        var notificationId =  data.additionalData["reference_id"];
        var nClickTrackUrl = data.additionalData["click_url"];
        if (null != nClickTrackUrl && undefined != nClickTrackUrl) {
          nClickTrackUrl+= deviceId;
          console.log("Sending notification click event to " + nClickTrackUrl);
          $.get(nClickTrackUrl, function(responseData, status, xhr) { 
            console.log("Notification click track call was successful");
          }).fail(function(responseData, status, xhr) {
            console.log("Notification click track call was unsuccessful with status " + xhr.status);
          });
        }
      }
    });

    pushNotification.on('error', function(e) {
        console.log("push error" + JSON.stringify(e));
    });
    
  },
  
  scanEnvironment: function() {
    if (window.CanOpen) {
      CanOpen('comgooglemaps://', function(mapsInstalled) {
        if (mapsInstalled) {
          Presto.env.ios.googleMapsInstalled = true;
        }
      });
    }
  },
  
  addGlobalClickHandlers: function(){
    if(typeof(device)!="undefined" && device.platform == "Android" && parseFloat(device.version) < 4.4){
      $(".menuLinks").on("touchstart",function(event){
        event.preventDefault();
        event.stopPropagation();
        return false;
      });
    }
  
    $('.leftControl').click(function(event) {
      console.debug("Back button clicked");
      Presto.showTemplate(Presto.app.backTemplateName, Presto.app.backTemplateData);
      PrestoAnalytics.trackEvent("buttonClick", "backButton");
    });
  
    $('#noOfItems').click(function(event) {
      console.debug("noOfItems clicked. Need to show order summary here");
      Presto.showOrderSummary();
      PrestoAnalytics.trackEvent("buttonClick", "cartCountButton");
    });

    $("#gift_check").click(function(event) {
      console.debug("Gift check box is clicked.");
      if(document.getElementById("gift_check").checked == true) {
       $("#gift_instructions").removeClass("hidden");
        $(".giftPersonalizeMessage").removeClass("hidden");
      }
      if(document.getElementById("gift_check").checked == false) {
        $("#gift_instructions").addClass("hidden");
        $(".giftPersonalizeMessage").addClass("hidden");
      }
    });
    
    $('.sb-toggle-left').click(function(event) {
    console.debug('Hamburger button clicked. Showing left sidebar');
    if( Presto.slidebars.state().state=="left" ){
          Presto.slidebars.close();
      } else {    
          Presto.slidebars.open('left');
      }
      PrestoAnalytics.trackEvent("buttonClick", "hamburgerButton");
    });
  
    $('#checkoutButton').click(function(event) {
      console.debug("Checkout button clicked");
      Presto.checkoutOrder();
      PrestoAnalytics.trackEvent("buttonClick", "checkoutButton");
    });
  
    Presto.slidebars.on('drag', function(){
          $("#presto-main-view-container").css({"overflow-y": 'hidden'});
        });
    Presto.slidebars.on('open', function(){
      $("#presto-main-view-container").css({"overflow-y": 'hidden'});
    });
    
    Presto.slidebars.on('close', function(){
       setTimeout(function(){
        if(Presto.slidebars.state().state == "closed"){
          $("#presto-main-view-container").css({"overflow-y": 'auto'});
        }else{
          $("#presto-main-view-container").css({"overflow-y": 'hidden'});
        }
      }, 100);
    });
    
  //Adding pause callback
  
  document.addEventListener('pause', function(event){
    Presto.pauseTime = new Date();
  });
    //Adding resume callback 
    document.addEventListener('resume', function(event){
      var currentDate = new Date();
    
      if(Presto.pauseTime){
      var timeDiffInMin = (currentDate - Presto.pauseTime)/(1000*60)
        //Fetch the catalog again if application was put to pause for more than 15 min. 
        if(timeDiffInMin >= 15){
          $.blockUI(Presto.getThrobberData("Resuming..."));
          Presto.resetOrder();
          if(Presto.merchant.show_menu_on_home && Presto.merchant.show_menu_on_home == "true"){
            if(Presto.merchant.hasCityBasedCatalog){
              $.blockUI(Presto.getThrobberData("Finding nearest outlet"));
              Presto.fetchNearestOutlet(function(nearestOutlet, sorted) {
                $.unblockUI();
                if(Presto.merchant.show_categories_in_bottom_bar){
                  Presto.fetchCatalogAndShowFirstCategoryForOutlet("category.hbs", Presto.merchant.nearestOutlet.id)
                }else {
                  Presto.fetchAndShowCatalogForOutlet("category.hbs", Presto.merchant.nearestOutlet.id);
                }              
              }, function(xhr, status, reason){
                $.unblockUI();
              });
            }else{
              if(Presto.merchant.show_categories_in_bottom_bar){
                Presto.fetchCatalogAndShowFirstCategoryForOutlet("category.hbs", null);
              }else {
                Presto.fetchAndShowCatalogForMerchant("category_list.hbs", Presto.merchant.id);
              }
            }            
          }else {
        $.unblockUI();
            Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
          }
        }
      }
      
    }, false);
  
  },
  
  bringHeaderToTop: function(event){
    if(Presto.slidebars.state().state == "left" && $("#headerContainer").css("position") == "absolute"){
      var top = $("#sb-site").scrollTop();
      $("#headerContainer").stop().animate({"top": top}, 10);
    }
  },
  
  addClickHandlers: function(backTemplateName, backTemplateData, options) {
    if (typeof(backTemplateName) === 'undefined' || typeof(backTemplateData) === 'undefined') {
      Presto.app.backTemplateName = 'www/templates/home.hbs';
      Presto.app.backTemplateData = Presto.merchant;
    } else {
      Presto.app.backTemplateName = backTemplateName;
      Presto.app.backTemplateData = backTemplateData;
    }
    if (!Presto.app.backbuttonWiredUp) {
      console.debug("Adding listener for backbutton");
      document.addEventListener('backbutton', function(event) {
        if (Presto.app.currentPage == 'home') {
          console.debug("Physical back button clicked while on home. Exiting app");
          navigator.app.exitApp();
          return false;
        } else {
          console.debug("Physical back button clicked while not on home. Going back");
          Presto.showTemplate(Presto.app.backTemplateName, Presto.app.backTemplateData);
          return false;
        }
      }, false);
      Presto.app.backbuttonWiredUp = true;
    }
    
    // XXX : TODO : Srirang : Temporary for YLG
    $("#list-catalogs-button").click(function(event) {
      console.debug("List catalogs (Shop) button clicked");
      console.debug("Showing hardcoded data now");
      Presto.showTemplate('www/templates/catalog_options.hbs');
    });

    $('#view-catalog-button').click(function(event) {
      // XXX : TODO : This has to change to fetchAndShowCatalog()
    if(Presto.merchant.chooseOutletBeforeOrder && !Presto.outletChosen) {
      Presto.showAlert("Please choose an outlet before ordering");
    return;
    }
      console.debug("Showing the catalog for the nearest store");
      Presto.showCurrentCatalog(event);
      PrestoAnalytics.trackEvent("buttonClick", "viewCatalogButton");
    });

    $('.viewCatalogButton').click(function(event) {
      // XXX : TODO : This has to change to fetchAndShowCatalog()
    if(Presto.merchant.chooseOutletBeforeOrder && !Presto.outletChosen) {
      Presto.showAlert("GOLI is not yet in your area. Coming Soon"); //Change this message
    return;
    }
      console.debug("Showing the catalog for the nearest store");
      Presto.showCurrentCatalog(event);
      PrestoAnalytics.trackEvent("buttonClick", "viewCatalogButton");
    });
  
    $(".viewServicesButton").click(function(event){
        console.debug("Showing the services catalog for the nearest store");
        Presto.showCurrentServicesCatalog(event);
        PrestoAnalytics.trackEvent("buttonClick", "viewServicesButton");
    });

    $('.viewCatalogAfterLocationEntered').click(function(event) {
      console.debug("Showing the catalog for the nearest store");
      var place = autocomplete.getPlace();
      if(Presto.outletChosen){
        if (Presto.merchant.nearestOutlet && !Presto.merchant.hasCommonCatalog) {
          console.debug("Nearest outlet already fetched. Showing catalog for outlet with id : " + Presto.merchant.nearestOutlet.id)
          var templateName = $(event.currentTarget).attr("data-template");
          Presto.fetchCatalogAndShowFirstCategoryForOutlet(templateName, Presto.merchant.nearestOutlet.id);
        } else {
          console.debug("Nearest outlet not available. Fetching nearest outlet and showing catalog for that outlet");
          var templateName = $(event.currentTarget).attr("data-template");
          Presto.fetchCatalogAndShowFirstCategoryForOutlet(templateName, null);
        }
        PrestoAnalytics.trackEvent("buttonClick", "viewCatalogButton");     
      } else{
        if(place == null){
          var areaData = "";
          if(areaData==""){
             Presto.showAlert("Please enter your delivery area");
          }else{
            Presto.showAlert(areaData); 
          }
        }else{
          var chosenLocation = place.geometry.location;
          var sortedOutlets = Presto.sortOutletsByDistance(Presto.merchant.outlets, {latitude: chosenLocation.lat(), longitude: chosenLocation.lng()});
          if(sortedOutlets.length > 0){
            if (Presto.merchant.nearestOutlet && !Presto.merchant.hasCommonCatalog) {
              console.debug("Nearest outlet already fetched. Showing catalog for outlet with id : " + Presto.merchant.nearestOutlet.id)
              var templateName = $(event.currentTarget).attr("data-template");
              Presto.fetchCatalogAndShowFirstCategoryForOutlet(templateName, Presto.merchant.nearestOutlet.id);
            } else {
              console.debug("Nearest outlet not available. Fetching nearest outlet and showing catalog for that outlet");
              var templateName = $(event.currentTarget).attr("data-template");
              Presto.fetchCatalogAndShowFirstCategoryForOutlet(templateName, null);
            }
          }
          PrestoAnalytics.trackEvent("buttonClick", "viewCatalogButton");         
        }
      }
    });
  
    $(".viewFirstCategoryInCatalogButton").click(function(event){
      if (Presto.merchant.nearestOutlet && !Presto.merchant.hasCommonCatalog) {
        console.debug("Nearest outlet already fetched. Showing catalog for outlet with id : " + Presto.merchant.nearestOutlet.id)
      var templateName = $(event.currentTarget).attr("data-template");
        Presto.fetchCatalogAndShowFirstCategoryForOutlet(templateName, Presto.merchant.nearestOutlet.id);
      } else {
        console.debug("Nearest outlet not available. Fetching nearest outlet and showing catalog for that outlet");
      var templateName = $(event.currentTarget).attr("data-template");
        Presto.fetchCatalogAndShowFirstCategoryForOutlet(templateName, null);
      }
    });

    $('#campaign-button').click(function(event) {
      console.debug("Showing the free waxing registration");
      Presto.showTemplate('www/templates/waxing.hbs', {login: Presto.user.loginStatus, merchant: Presto.merchant});
      PrestoAnalytics.trackEvent("buttonClick", "viewCampaignButton");
    });
  
    $("#showOrderSummaryButton").click(function(event){
      console.debug("show order summary clicked. Need to show order summary here");
      Presto.showOrderSummary();
      PrestoAnalytics.trackEvent("buttonClick", "showOrderSummaryButton");
    });

    $(".showOrderSummaryButton").click(function(event){
      console.debug("show order summary clicked. Need to show order summary here");
      Presto.showOrderSummary();
      PrestoAnalytics.trackEvent("buttonClick", "showOrderSummaryButton");
    });
    
    $('#quick-order-button').click(function(event) {
      console.debug("Showing the quick order screen");
      Presto.showQuickOrderScreen(event);
      PrestoAnalytics.trackEvent("buttonClick", "quickOrderButton");
    });
    $('.categoryItem').off("click");
    $('.categoryItem').click(function(event) {
      console.debug("Clicked on a category");
      Presto.showCategoryItems(event);
      PrestoAnalytics.trackEvent("buttonClick", "categoryLabelClick", $(event.currentTarget).attr("data-categoryName"));
    });
    
    $(".serviceCategory").click(function(event){
      console.debug("Clicked on a category");
      Presto.showServiceCategoryItems(event);
      PrestoAnalytics.trackEvent("buttonClick", "categoryLabelClick", $(event.currentTarget).attr("data-categoryName"));
    });
    
    $('.favItem').off("click");
    var catalogData = {
    catalog: Presto.merchant.catalog
    };
    $('.favItem').click(function(event) {
      console.debug("Clicked on a favourite item");
      Presto.showTemplate('www/templates/category_list.hbs', catalogData);
    });
    // XXX : TODO : Srirang : Temporary for YLG
    $(".catalogOption").click(function(event) {
      var catalogOptionId = $(event.currentTarget).attr("data-catalogOption-id");
      console.debug("Catalog option clicked. Id = " + catalogOptionId);
      if (Presto.merchant.catalogOptionsData[catalogOptionId]) {
        Presto.showTemplate('www/templates/catalog_items.hbs', Presto.merchant.catalogOptionsData[catalogOptionId]);
      }
    });
  
    $(".sidebar-catalogOptionsButton").click(function(event) {
      var catalogOptionId = $(event.currentTarget).attr("data-catalogOption-id");
      console.debug("Catalog option clicked. Id = " + catalogOptionId);
      if (Presto.merchant.catalogOptionsData[catalogOptionId]) {
        Presto.showTemplate('www/templates/catalog_items.hbs', Presto.merchant.catalogOptionsData[catalogOptionId]);
      }
    });
  
    $(".catalogItemDetail").click(function(event){
      var $target = $(event.currentTarget);
      var catalogOptionId = $target.attr("data-catalogOption-id");
      var catalogItemId = $target.attr("data-catalogItem-id");
        if (Presto.merchant.catalogOptionsData[catalogOptionId] && Presto.merchant.catalogOptionsData[catalogOptionId][catalogItemId]) {
          Presto.showTemplate('www/templates/catalog_item_view.hbs', Presto.merchant.catalogOptionsData[catalogOptionId][catalogItemId]);
        }
    });
    
    $('#find-outlets-button').click(function(event) {
      console.debug("Showing the list of stores");
      Presto.fetchAndShowOutlets(false);
      PrestoAnalytics.trackEvent("buttonClick", "findOutletsButton");
    });
    
    $(".listOutlets").click(function(event){
      var cityName = $(event.currentTarget).attr("data-cityName");
      if(Presto.merchant.outlets.length == 0){
        $.blockUI(Presto.getThrobberData("Fetching outlets"));
        Presto.fetchNearByOutlets(function(outletsData, sortedOrNot) {
          $.unblockUI();
          Presto.listOutlets(cityName);
        });
      }else {
        Presto.listOutlets(cityName);
      }
    });
    
    //Show outlet detail page.
    $(".outletDetailsPage").click(function(event){
      var outletId = $(event.currentTarget).attr("data-outletId");
      var outlet = Presto.merchant.outletsHash[outletId];
    Presto.merchant.nearestOutlet = outlet;
      Presto.showOutletDetailPage(outlet);
    });
    
    $(".appointmentDate").click(function(event){
      if(Presto.merchant.delivery_for_certain_date){
        console.log(Presto.merchant.delivery_for_certain_date);
        var newDate = new Date();
        if(Presto.merchant.minimum_date_for_delivery) {
        console.log(Presto.merchant.minimum_date_for_delivery);
          var minMillis = newDate.getTime() + parseInt(Presto.merchant.minimum_date_for_delivery);
        }
        if(Presto.merchant.maximum_date_for_delivery) {
        console.log(Presto.merchant.maximum_date_for_delivery);
          var maxdate = newDate.getTime() + parseInt(Presto.merchant.maximum_date_for_delivery);
        }
        var options = {
          date: newDate,
          mode: 'date',
          minDate: minMillis,
          maxDate: maxdate
        };
      }else {
        var options = {
          date: new Date(),
          mode: 'date',
          minDate : new Date()
        };
      }
      datePicker.show(options, function(date){
        Presto.chosenAppointmentDate = date;
        $(".appointmentDate").val(date.toDateString());
      });
    });
    
    $(".appointmentTime").change(function(event){
      Presto.chosenAppointmentTime = $(".appointmentTime").val();
    });
  
    $(".selectService").click(function(event){
      var anchorTag = $(event.currentTarget).find("a");
      var service = $(anchorTag).attr("data-serviceId");
      if($(anchorTag).hasClass("selected")){
        $(anchorTag).removeClass("selected");
        if(Presto.chosenServices.indexOf(service) != -1){
          Presto.chosenServices.splice( $.inArray(service, Presto.chosenServices), 1 );
        }
      }else {
        $(anchorTag).addClass("selected");
        if(Presto.chosenServices.indexOf(service) == -1){
          Presto.chosenServices.push(service);
        }
      }
    });
    
    $(".bookAppointmentButton").click(function(event){
      Presto.bookAppointment(event);
    });
    
    /*
     * Clicking on an outlet should take the user to the map and not show the catalog for that outlet.
     * Disabling this event handler. Similar code would be called for the "Place Order button"
     */
    if (typeof(options) != "undefined" && options.showCatalogForOutlet) {
      console.debug("Current outlets list should show catalog on clicking. So adding that event listener");
      $('.listedOutlet').click(function(event) {
        var outletId = $(event.currentTarget).attr("data-outletId");
        console.debug("Fetching catalog for outletId = " + outletId);
        Presto.merchant.nearestOutlet = Presto.merchant.outletsHash[outletId];
        Presto.outletChosen = true;
        var templateName = $(event.currentTarget).attr("data-template");
        Presto.fetchAndShowCatalogForOutlet(templateName, outletId);
        Presto.resetOrder();
        PrestoAnalytics.trackEvent("buttonClick", "listedOutletLabelClick", outletId);
        return false;
      });
    }
    
    $('#selectedOutlet').click(function(event) {
      console.debug("Selected outlet clicked. User changing the outlet to order from. Showing outlets list");
      PrestoAnalytics.trackEvent("buttonClick", "selectedOutletClick");
      Presto.fetchAndShowOutlets(true);
    });
  
    $('.selectedOutlet').off("click");
    $('.selectedOutlet').click(function(event) {
      console.debug("Selected outlet clicked. User changing the outlet to order from. Showing outlets list");
      PrestoAnalytics.trackEvent("buttonClick", "selectedOutletClick");
      Presto.fetchAndShowOutlets(true);
    });
    
    $("#outlets-map-view-button").click(function(event) {
      console.debug("Map button clicked. Showing outlets on a map");
      Presto.showTemplate("www/templates/map_search_view.hbs");
      PrestoAnalytics.trackEvent("buttonClick", "outletsMapViewButton");
    })
    
    $('.individualItem').click(function(event) {
      console.debug("Individual item clicked");
      var itemId = $(event.currentTarget).attr("data-itemId");
      var categoryId = $(event.currentTarget).attr("data-categoryId");
      Presto.showItem(itemId, categoryId);
      PrestoAnalytics.trackEvent("buttonClick", "itemLabelClick", itemId);
    });
  
    $('.itemAdd').click(function(event) {
      console.debug("Adding an item");
      var itemId = $(event.currentTarget).attr("data-itemId");
      var categoryId = $(event.currentTarget).attr("data-categoryId");
      var variationId = $(event.currentTarget).attr("data-variationId");
      Presto.addItemtoOrder(itemId, categoryId, variationId);
      var refreshOrder = $(event.currentTarget).attr("data-refreshOrder");
      if(refreshOrder){
        if (Presto.merchant.needUserDetailsInOrderSummary) {
          var templateData = {
            user: Presto.user,
            order: Presto.user.order
          };
          Presto.showTemplate('www/templates/order_summary.hbs', templateData, true);
        } else {
          Presto.showTemplate('www/templates/order_summary.hbs', Presto.user.order, true);
        }
      }else {
        $(".orderTotalAmount").html(parseInt(Presto.user.order.billAmount));
      }
      PrestoAnalytics.trackEvent("buttonClick", "itemAddButton", itemId);
      PrestoAnalytics.trackEvent("order", "addItem", itemId);
    });
    
    $('.itemRemove').click(function(event) {
      console.debug("Removing an item");
      var itemId = $(event.currentTarget).attr("data-itemId");
      var categoryId = $(event.currentTarget).attr("data-categoryId");
      var variationId = $(event.currentTarget).attr("data-variationId");
      Presto.removeItemFromOrder(itemId, categoryId, variationId);
      var refreshOrder = $(event.currentTarget).attr("data-refreshOrder");
      if(refreshOrder){
        if(Presto.user.order.noOfItems > 0){
          if (Presto.merchant.needUserDetailsInOrderSummary) {
            var templateData = {
              user: Presto.user,
              order: Presto.user.order
            };
            Presto.showTemplate('www/templates/order_summary.hbs', templateData, true);
          } else {
          Presto.showTemplate('www/templates/order_summary.hbs', Presto.user.order, true);
          }
        }else{
          if (Presto.merchant.needUserDetailsInOrderSummary) {
            Presto.fetchCatalogAndShowFirstCategoryForOutlet('category.hbs', null);
          } else if(Presto.merchant.has_menu_in_category_page) {
            Presto.showCatalog("category.hbs");
          } else {
            Presto.showCatalog();
          }
        }
      }else {
        $(".orderTotalAmount").html(parseInt(Presto.user.order.billAmount));
      }
      PrestoAnalytics.trackEvent("buttonClick", "itemRemoveButton", itemId);
      PrestoAnalytics.trackEvent("order", "removeItem", itemId);
    });
    
    $('#placeOrderWithSignup').click(function(event) {
      console.debug("Place order clicked for logged out user");
      Presto.placeOrderWithSignup();
      PrestoAnalytics.trackEvent("buttonClick", "placeOrderButton", "loggedOut");
      PrestoAnalytics.trackEvent("order", "placeOrder", "loggedOut");
    });
    
    $('#placeOrderWithSignupPayOnline').click(function(event) {
      console.debug("Place order pay online clicked for logged out user");
      Presto.placeOrderWithSignup("ONLINE");
      PrestoAnalytics.trackEvent("buttonClick", "placeOrderPayOnlineButton", "loggedOut");
      PrestoAnalytics.trackEvent("order", "placeOrder", "loggedOut");
    });
    
    $('#placeOrderWithSignupPayButton').click(function(event) {
      var paymentType = $(event.currentTarget).attr("data-paymentType");
      if(paymentType == "ONLINE"){
        console.debug("Place order pay online clicked for logged out user");
        Presto.placeOrderWithSignup("ONLINE");
        PrestoAnalytics.trackEvent("buttonClick", "placeOrderPayOnlineButton", "loggedOut");
        PrestoAnalytics.trackEvent("order", "placeOrder", "loggedOut");
      }else {
        console.debug("Place order clicked for logged out user");
        Presto.placeOrderWithSignup();
        PrestoAnalytics.trackEvent("buttonClick", "placeOrderButton", "loggedOut");
        PrestoAnalytics.trackEvent("order", "placeOrder", "loggedOut");
      }
    });
    
    $('.showLoginPage').click(function(event) {
      console.debug("Showing login page");
      var currentPage = $(event.currentTarget).attr("data-currentPage");
      Presto.showLoginPage(currentPage);
      PrestoAnalytics.trackEvent("buttonClick", "loginButton");
    });
  
    $(".showSignupPage").click(function(event) {
      var lastPage = Presto.app.currentPage;
      if (lastPage == 'home') {
        lastPage = 'www/templates/home.hbs';
      }
      //Presto.slidebars.toggle('left');
      Presto.showSignupPage(lastPage);
      PrestoAnalytics.trackEvent("buttonClick", "signupButton");
    });
    
    $('#loginButton').click(function(event) {
      console.debug("Login button clicked");
      var lastPage = $(event.currentTarget).attr("data-lastPage");
      Presto.loginUser(lastPage);
      PrestoAnalytics.trackEvent("buttonClick", "loginSubmitButton");
    });
    
    $('.showResetPasswordPage').click(function(event) {
      console.debug("Showing Reset Password page");
      var currentPage = $(event.currentTarget).attr("data-currentPage");
      Presto.showResetPasswordPage(currentPage);
      PrestoAnalytics.trackEvent("buttonClick", "resetPasswordButton");
    });
    
    $('#resetPasswordButton').click(function(event) {
      console.debug("Reset button clicked");
      var lastPage = $(event.currentTarget).attr("data-lastPage");
      Presto.resetPassword(lastPage);
      PrestoAnalytics.trackEvent("buttonClick", "resetPasswordSubmitButton");
    });
    
    $(".showSetPasswordPage").click(function(event){
      var currentPage = $(event.currentTarget).attr("data-currentPage");
      var login = $("#user_login").val();
      if(!login || login == ""){
        Presto.showAlert("Please enter your email address");
        return;
      }
      Presto.showSetPasswordPage(currentPage, login);
    });
    
    $('#setPasswordButton').click(function(event) {
      console.debug("Set button clicked");
      var lastPage = $(event.currentTarget).attr("data-lastPage");
      Presto.setPassword(lastPage);
      PrestoAnalytics.trackEvent("buttonClick", "setPasswordSubmitButton");
    });
    
    $('#chooseAddress').click(function(event) {
      console.debug("Choose Another Address clicked");
      Presto.showAddressOptions();
      PrestoAnalytics.trackEvent("buttonClick", "chooseAnotherAddressButton");
    });

    $('#track-order-button').click(function(event){
      console.debug("Showing tracking order page");
      Presto.trackAndShowLastOrder();
      PrestoAnalytics.trackEvent("buttonClick", "trackOrder");
    });

    $("#inviteFriends-button").click(function(){
      console.debug("Showing invite friends page");
      Presto.inviteFriends();
      PrestoAnalytics.trackEvent("buttonClick", "inviteFriends");
    });

    $(".editControl").click(function(event){
      console.debug("Edit user is clicked");
      Presto.showTemplate('www/templates/user_details.hbs', Presto.user);
      PrestoAnalytics.trackEvent("buttonClick", "editUser");
    });

    $("#updateUserData").click(function(event) {
      console.debug("UpdateUseData button is clicked");
      var userId = $(event.currentTarget).attr("data-userId");
      Presto.editUserDetails(userId);
      PrestoAnalytics.trackEvent("buttonClick", "UpdateUser");
    });
    
    $('.userAddress').click(function(event) {
      console.debug("An address chosen");
      var addressId = $(event.currentTarget).attr('data-addressId');
      Presto.updateChosenAddress(addressId);
      PrestoAnalytics.trackEvent("buttonClick", "addressChosen");
    });
    
    $("#addAddress").click(function(event) {
      console.debug("Add address clicked");
      Presto.addAddress();
      PrestoAnalytics.trackEvent("buttonClick", "addAddressButton");
    });
  
    $("#addAccountAddress").click(function(event) {
      console.debug("Add account address clicked");
      Presto.addAccountAddress();
      PrestoAnalytics.trackEvent("buttonClick", "addAccountAddress");
    });
    
    $('.deleteUserAddress').click(function(event) {
      var addressId = $(event.currentTarget).attr('data-addressId');
      console.debug('Address delete button clicked for address with id : ' + addressId);
      Presto.deleteUserAddress(addressId);
      PrestoAnalytics.trackEvent("buttonClick", "deleteUserAddress");
    });
    
    $('#placeOrderLoggedIn').click(function(event) {
      console.debug("Place order clicked for logged in user");
      Presto.placeOrderLoggedIn();
      PrestoAnalytics.trackEvent("buttonClick", "placeOrderButton", "loggedIn");
      PrestoAnalytics.trackEvent("order", "placeOrder", "loggedIn");
    });
    
    $('#placeOrderLoggedInPayOnline').click(function(event) {
      console.debug("Place order clicked for logged in user. Pay online button chosen");
      Presto.placeOrderLoggedIn("ONLINE");
      PrestoAnalytics.trackEvent("buttonClick", "placeOrderPayOnlineButton", "loggedIn");
      PrestoAnalytics.trackEvent("order", "placeOrder", "loggedIn");
    });
    
    $('#placeOrderLoggedInPayButton').click(function(event) {
      var paymentType = $(event.currentTarget).attr("data-paymentType");
      if(paymentType == "ONLINE"){
        console.debug("Place order clicked for logged in user. Pay online button chosen");
        Presto.placeOrderLoggedIn("ONLINE");
        PrestoAnalytics.trackEvent("buttonClick", "placeOrderPayOnlineButton", "loggedIn");
        PrestoAnalytics.trackEvent("order", "placeOrder", "loggedIn");
      }else {
        console.debug("Place order clicked for logged in user");
        Presto.placeOrderLoggedIn();
        PrestoAnalytics.trackEvent("buttonClick", "placeOrderButton", "loggedIn");
        PrestoAnalytics.trackEvent("order", "placeOrder", "loggedIn");
      }  
    });
    
    $('.doneButton').click(function(event) {
      console.debug("Done button clicked");
      if(Presto.merchant.homeControlToCategory) {
        Presto.clearOrderAndShowCategory();
      } else {
        Presto.clearOrderAndShowHome();
      }
      PrestoAnalytics.trackEvent("buttonClick", "doneButton");
    });
    
    $('#placeAnotherOrder').click(function(event) {
      console.debug("Place another order clicked");
      Presto.showCurrentCatalog(event);
      PrestoAnalytics.trackEvent("buttonClick", "placeAnotherOrder");
    });
    
    
    $('#share-button').click(function(event) {
      window.plugins.socialsharing.shareViaFacebook(null, null, '', 
        function(success) {
          if (success) {
            console.debug('FB Share succeeded');
          } else {
            console.debug('FB Share failed');
          }
        }, function (errormsg) {
          console.error('Error callback called');
          console.error(errormsg);
          var fbErrorMessage = Presto.merchant.fb_share_error;
          if(fbErrorMessage=="") {
          Presto.showAlert("You need to have the Facebook app installed on your phone to share this on Facebook");
          } else {
          Presto.showAlert(Presto.merchant.fb_share_error);
          }
        }
      );
    });

    $("#share-code").click(function(event) {
    PrestoAnalytics.trackEvent("buttonClick", "Share your code");
       var code = $(event.currentTarget).attr('data-ref_code');
       Presto.merchant.message = Presto.merchant.message.replace("REF_CODE", code);
       window.plugins.socialsharing.share(Presto.merchant.message, Presto.merchant.subject, null, Presto.merchant.link, 
        function(success) {
          if (success) {
            console.debug('Share succeeded');
          } else {
            console.debug('Share failed');
          }
        }, function (errormsg) {
          console.error('Error callback called');
          console.error(errormsg);
        }
      );
    });
  
    $(".clearCartControl").click(function(event){
      console.debug("Clear cart clicked");
      if(Presto.merchant.clearCartToCategory){
        Presto.clearOrderAndShowCategory();
      }else{
        Presto.clearOrderAndShowHome();
      }
      PrestoAnalytics.trackEvent("buttonClick", "clearCartButton");
      PrestoAnalytics.trackEvent("order", "clearCart")
    });
  
    $("#largeCheckoutButton").click(function(event){
      console.debug("Checkout button clicked");
      Presto.checkoutOrder();
      PrestoAnalytics.trackEvent("buttonClick", "checkoutButton");
      PrestoAnalytics.trackEvent("order", "checkout");
    });
  
    $('#accountFavourites').click(function(event) {
      console.debug("Favourites button in the sidebar clicked");
      //Presto.slidebars.toggle('left');
      Presto.showFavouriteItems();
      PrestoAnalytics.trackEvent("buttonClick", "showFavorites")
      return false;
    });
  
    $('#accountOffers').click(function(event) {
      console.debug("Offers button in the manage clicked");
      Presto.showOffers();
      PrestoAnalytics.trackEvent("buttonClick", "myOffersButton")
      return false;
    });
  
    $("#sendFeedback").click(function(event){
      $.blockUI(Presto.getThrobberData("Sending Feedback"));
      PrestoAnalytics.trackEvent("buttonClick", "feedbackSubmitButton")
    var feedbackUrl = "http://" + Presto.app.host + "/feedback.json";
    var message = $("#feedbackMessage").val();
    var data = {
      "feedback": {
        "message": message,
        "rating": Presto.feedbackRating
    },
    "app_id": Presto.merchant.app_id
    };
      $.post(feedbackUrl, data, function(offers, status, xhr) {
        $.unblockUI();
        Presto.showTemplate('www/templates/feedback_thankyou.hbs',{merchant: Presto.merchant});
      }).fail(function(xhr, status, error) {
        $.unblockUI();
        Presto.showTemplate('www/templates/feedback_thankyou.hbs',{merchant: Presto.merchant});
      });
    });
  
    $("#userSignUpButton").click(function(event){
      PrestoAnalytics.trackEvent("buttonClick", "userSignupButton")
      var letters = /^[A-Za-z\ ]+$/;
      if(!$("#userSignupName").val().trim().match(letters)){
        Presto.showAlert("Please enter valid name with alphabet characters only");
        return;
      }

      var phone_number = $("#userSignupPhone").val();
      //Regex is to match the leading 0 or 91 or +91 followed by 10 digits
      var phone_number_match_regex = /^(?:(?:\+|)91|[0]?)?\d{10}$/
  
      if(!phone_number.match(phone_number_match_regex)){
        Presto.showAlert("Please enter a valid phone number!");
        return;
      }

      if($("#userSignupEmail").val() == "" && ($("#userSignupEmail").attr("required") == "true" || $("#userSignupEmail").attr("required") == "required")){
        Presto.showAlert("Please enter your email to place the order");
        return;
      }

      if($("#userSignupPassword").length > 0 && $("#userSignupPassword").val().length < 8){
        Presto.showAlert("Password should be atleast 8 characters");
        return;
      }
    
      $.blockUI(Presto.getThrobberData("Registering"));
        var data = {
          "user": {
            "phone_number": $("#userSignupPhone").val(),
            "password": $("#userSignupPassword").val(),
            "merchant_id": Presto.merchant.id,
            "name": $("#userSignupName").val(),
            "email": $("#userSignupEmail").val()
          }
        };
      var signupUrl = "http://" + Presto.app.host + "/users.json";
        $.post(signupUrl, data, function(offers, status, xhr) {
          $.unblockUI();
          Presto.showAlert("Registered successfully");
          Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
          Presto.user.loginStatus = true;
          Presto.fetchAndUpdateUserData(function() {
            Presto.populateSidebarView();
          }, function() {
          });
        
        }).fail(function(xhr, status, error) {
          $.unblockUI();
          var error_msg = JSON.parse(xhr.responseText).message.replace("\n", "<br/>");
          Presto.showAlert("Unable to register <br/>" + error_msg);
        });
    });
  
    $(".showResetPasswordPage").click(function(event){
      var lastPage = Presto.app.currentPage;
      if (lastPage == 'home') {
        lastPage = 'www/templates/home.hbs';
      }
      Presto.showResetPasswordPage(lastPage);
    });
    
    $(".applyCoupon").click(function(event){      
      Presto.checkAndApplyDiscountCoupon(event);
    });

    $(".variation").click(function(event){
      $target = $(event.currentTarget);
      $target.closest(".variations").find(".variation").removeClass("selected");
      $target.addClass("selected");
      card = $target.closest(".card");
      card.find(".order-value").html("₹ " + $target.attr("data-variationPrice"));
      console.log($target.attr("data-variationImage"));
      card.find(".itemAdd").attr("data-variationId", $target.attr("data-variationId"));
      card.find(".itemRemove").attr("data-variationId", $target.attr("data-variationId"));
      card.find(".count").attr("id", card.find(".itemAdd").attr("data-itemId") + $target.attr("data-variationId") + "-count");
      var currentItem = Presto.findItemInCategory(card.find(".itemAdd").attr("data-itemId"), card.find(".count").attr("data-categoryId"), $target.attr("data-variationId"));
      card.find(".menu-image").css({"background-image" : "url(" + $target.attr("data-variationImage") +")"});
      if(!currentItem.addedCount) {
        currentItem.addedCount = 0;
        card.find(".itemRemove").addClass("hidden");
        card.find(".count").addClass("hidden");
      }else {
        card.find(".itemRemove").removeClass("hidden");
        card.find(".count").removeClass("hidden");
      }
      card.find(".count").html(currentItem.addedCount);
    });
    
  },
  
  addSidebarClickHandlers: function() {
    $(".homeControl").click(function(event) {
      if(Presto.merchant.homeControlToCategory) {
        Presto.fetchCatalogAndShowFirstCategoryForOutlet('category.hbs', null);
      }else {
        Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
      }
      PrestoAnalytics.trackEvent("buttonClick", "homeButton");
    });

    $(".manageAccount").click(function(event){
      Presto.showTemplate('www/templates/manage_account.hbs', Presto.user);
      if(Presto.merchant.prepaid_card_enabled && Presto.user.ppcData){
        $(".prepaidMeter").html(Presto.templates["www/templates/prepaid_meter.hbs"](Presto.user.ppcData));
        $(".prepaidDetails").html(Presto.templates["www/templates/prepaid_details.hbs"](Presto.user.ppcData));
      }else if(Presto.merchant.prepaid_card_enabled){
        $(".prepaidDetails").html("<br/><p>Prepaid card details are currently not available. Please try again later or contact nearest store<br/><br/></p>");
      }
      PrestoAnalytics.trackEvent("buttonClick", "manageAccountButton");
    });
    
    $('#sidebar-loginButton').click(function(event) {
      console.debug("Login button in the sidebar clicked");
      var lastPage = Presto.app.currentPage;
      if (lastPage == 'home') {
        lastPage = 'www/templates/home.hbs';
      }
      //Presto.slidebars.toggle('left');
      Presto.showLoginPage(lastPage);
      PrestoAnalytics.trackEvent("buttonClick", "sidebarLoginButton")
      return false;
    });
  
    $('#sidebar-signUpButton').click(function(event) {
      console.debug("Signup button in the sidebar clicked");
      var lastPage = Presto.app.currentPage;
      if (lastPage == 'home') {
        lastPage = 'www/templates/home.hbs';
      }
      //Presto.slidebars.toggle('left');
      Presto.showSignupPage(lastPage);
      PrestoAnalytics.trackEvent("buttonClick", "sidebarSignupButton");
      return false;
    });

    $('#side-bar-track-order').click(function(event) {
      console.debug("Showing tracking order page");
      Presto.trackAndShowLastOrder();
      PrestoAnalytics.trackEvent("buttonClick", "trackOrder");
    });

    $("#side-bar-inviteFriends").click(function(){
      console.debug("Showing invite friends page");
      Presto.inviteFriends();
      PrestoAnalytics.trackEvent("buttonClick", "inviteFriends");
    });
    
    $(".sidebar-notificationsButton").click(function(event){
      console.debug("Notifications in the sidebar clicked");
      var lastPage = Presto.app.currentPage;
      if (lastPage == 'home') {
        lastPage = 'www/templates/home.hbs';
      }
      Presto.showNotifications(lastPage);
      PrestoAnalytics.trackEvent("buttonClick", "sidebarNotificationButton");
      return false;
    });
    
    $('#sidebars-favourites-button').click(function(event) {
      console.debug("Favourites button in the sidebar clicked");
      //Presto.slidebars.toggle('left');
      Presto.showFavouriteItems();
      PrestoAnalytics.trackEvent("buttonClick", "sidebarFavoritesButton");
      return false;
    });
  
    $('#sidebars-offers-button').click(function(event) {
      console.debug("Offers button in the sidebar clicked");
      //Presto.slidebars.toggle('left');
      Presto.showOffers();
      PrestoAnalytics.trackEvent("buttonClick", "sidebarOffersButton");
      return false;
    });
  
    $("#sidebar-feedback").click(function(event){
      console.debug("Feedback click in the sidebar clicked");
      Presto.showFeedback();
      PrestoAnalytics.trackEvent("buttonClick", "sidebarFeedbackButton")
      return false;
    });
    
    $("#sidebar-logout-button").click(function(event) {
      console.debug("Logout button in sidebar clicked");
      //Presto.slidebars.toggle('left');
      Presto.logoutUser();
      PrestoAnalytics.trackEvent("buttonClick", "sidebarLogoutButton");
      if(Presto.merchant.catalog.id){
      $(".homeControl").click();
      }
    });
  
    $('.sidePanelCategoryItem').click(function(event) {
      console.debug("Clicked on a category");
      Presto.showCategoryItems(event);
      PrestoAnalytics.trackEvent("buttonClick", "sidebarCategoryClick")
    });
  
    $('#selectedOutletSidePanel').click(function(event) {
      console.debug("Selected outlet clicked. User changing the outlet to order from. Showing outlets list");
      Presto.fetchAndShowOutlets(true);
      PrestoAnalytics.trackEvent("buttonClick", "sidebarSelectedOutletLabel")
    });
  
    $('#sidebar-placeOrder').click(function(event) {
      // XXX : TODO : This has to change to fetchAndShowCatalog()
      if(Presto.merchant.chooseOutletBeforeOrder && !Presto.outletChosen) {
        Presto.showAlert("Please choose an outlet before ordering");
        return;
      }
      console.debug("Showing the catalog for the nearest store");
      Presto.showCurrentCatalog(event);
      PrestoAnalytics.trackEvent("buttonClick", "sidebarBrowseCatalog");
    });
    
    $('#sidebar-findOutlets').click(function(event) {
      console.debug("Showing the list of stores");
      Presto.fetchAndShowOutlets(false);
      PrestoAnalytics.trackEvent("buttonClick", "sidebarFindOutlets")
    });
  
    $("#aboutUsLink").click(function(event) {
      Presto.showTemplate('www/templates/about.hbs', Presto.merchant);
      PrestoAnalytics.trackEvent("buttonClick", "aboutUsButton")
    });

    $('#sidebar-All-order').click(function(event){
      console.debug("Showing tracking order page");
      Presto.showAllOrdersPage();
      PrestoAnalytics.trackEvent("buttonClick", "trackOrder");
    });
    
    $(".showResetPasswordPageFromSidebar").click(function(event){
      var lastPage = Presto.app.currentPage;
      if (lastPage == 'home') {
        lastPage = 'www/templates/home.hbs';
      }
      Presto.showResetPasswordPage(lastPage);
    });
    $(".sidebarListOutlets").click(function(event){
      
      var cityName = $(event.currentTarget).attr("data-cityName");
      
      if(Presto.merchant.outlets.length == 0){
        $.blockUI(Presto.getThrobberData("Fetching outlets"));
        Presto.fetchNearByOutlets(function(outletsData, sortedOrNot) {
          $.unblockUI();
          Presto.listOutlets(cityName);
        });
      }else {
        Presto.listOutlets(cityName);
      }
      
    });
  },
  
  listOutlets: function(cityName){
    if(!cityName || cityName == ""){
      if(Presto.merchant.nearestOutlet && Presto.merchant.nearestOutlet.address){
        cityName = Presto.merchant.nearestOutlet.address.city;
      }else if(Presto.merchant.outlets[0].address){
        cityName = Presto.merchant.outlets[0].address.city;
      }else { 
        cityName = "Bangalore";
      }
    }
    
    var outlets = Presto.merchant.cityBasedOutlets[cityName];
    
    var outletsData = {
      outlets: outlets,
      citySelected: cityName,
      showCatalogForOutlet: 'false',
      outletCities: Presto.merchant.outletCities
    };
    Presto.showTemplate('www/templates/outlets.hbs', outletsData);
  },
  
  bookAppointment: function(event) {
    var services = []
    if(!Presto.chosenServices || Presto.chosenServices.length == 0){
      Presto.showAlert("Please choose atleast one service");
      return;
    }
    if(!Presto.chosenAppointmentDate){
      Presto.showAlert("Please choose an appointment date");
      return;
    }

    if(!Presto.chosenAppointmentTime){
      Presto.showAlert("Please choose your preferred time");
      return;
    }
    var today = new Date();
    Presto.chosenAppointmentDate.setHours(parseInt(Presto.chosenAppointmentTime));
    if(Presto.chosenAppointmentDate < today){
      Presto.showAlert("Please select correct date");
      return;
    }
    
    if(Presto.user.loginStatus){
      userData = Presto.buildLoggedInUserData();
    }else {
      userData = Presto.buildUserRegistrationData();
    }
    var appointmentData = Presto.buildAppointmentData();
    appointmentData.user = userData;
    
    postData = {
      authenticity_token: Presto.app.authToken,
      appointment: appointmentData
    };
    postData.appointment.address = userData.address;
    Presto.submitAppointment(postData);
    
  },
  
  buildAppointmentData: function(){
    appointmentData = {
        outlet_id: Presto.merchant.catalog.outlet_id,
        merchant_id: Presto.merchant.id,
        date: Presto.chosenAppointmentDate,
        services: Presto.chosenServices,
        time_slot: Presto.chosenAppointmentTime
      };
      
    return appointmentData;
  },
  
  submitAppointment: function(data) {
      postData.merchant_id = Presto.merchant.id;
      postData.app_id = Presto.merchant.app_id;
      var appointmentUrl = "http://" + Presto.app.host + "/appointments.json"
      console.debug("Sending POST request to " + appointmentUrl + " with data = \n" + JSON.stringify(postData));
      $.blockUI(Presto.getThrobberData("Booking your appointment"));
      $.ajax(appointmentUrl, {
        type: 'POST',
        data: JSON.stringify(postData),
        contentType: 'application/json; charset=utf-8',
        //dataType: 'json',
        success: function(responseData, status, xhr) {
          $.unblockUI();
      Presto.showAppointmentConfirmation(postData);
      Presto.fetchAndUpdateUserData();
        },
        
        error: function(xhr, status, reason){
          $.unblockUI();
          try{
            console.debug("Appointment booking failed with status : " + status);
            console.debug(xhr.responseText);
            var responseData = JSON.parse(xhr.responseText);
            var errorMessage = "";
            if(typeof(responseData.msg) != "undefined"){
              errorMessage = responseData.msg;
            }
            else if(typeof(responseData.message) != "undefined"){
              errorMessage = responseData.message;
            }
            else if(typeof(responseData.error_message) != "undefined"){
              errorMessage = responseData.error_message;
            }
            Presto.showAlert("Could not book appointment - " + errorMessage);
          }catch(e){
            
          }
          //Presto.showAppointmentConfirmation();
        }
      });
      
  },
  
  showAppointmentConfirmation: function(postData) {
    var outlet = Presto.merchant.outletsHash[Presto.merchant.catalog.outlet_id];
    var data = {
      outlet: outlet,
      date: Presto.chosenAppointmentDate,
      services: Presto.chosenServices,
      time: Presto.chosenAppointmentTime,
      user: Presto.user,
      postData: postData
    }
    console.log(data);
    Presto.showTemplate('www/templates/appointment_confirmation.hbs', data);
  },  
  
  showOutletDetailPage: function(outlet) {
    if(!outlet.services){
      if(Presto.merchant.servicesCatalog){
        if(outlet.address && outlet.address.city && outlet.address.city == Presto.merchant.servicesCatalog.filter ){
          outlet.services = Presto.merchant.servicesCatalog.categories;
          Presto.populateOutletDetailTemplate(outlet);
        }else {
          Presto.fetchServicesCatalogForOutlet(outlet.id, function(){
            outlet.services = Presto.merchant.servicesCatalog.categories;
            Presto.populateOutletDetailTemplate(outlet);
          });
        }
      }else {
        Presto.fetchServicesCatalogForOutlet(outlet.id, function(){
          outlet.services = Presto.merchant.servicesCatalog.categories;
          Presto.populateOutletDetailTemplate(outlet);
        });
      }
    }else {
      Presto.populateOutletDetailTemplate(outlet);
    }
  },

  timeDateSlot: function() {
    var userChoosenTime = $("#timeSlot").val();
    var userChoosenDate = $("#dateSlot").val();
    var newDate = new Date(userChoosenDate);
    if ($("#timeSlot option:selected").text() == "9.00 AM - 12.00 Noon") {
      console.debug("selctedtime=" + userChoosenTime);
      newDate.setHours(9);
    }
    if ($("#timeSlot option:selected").text() == "12.00 Noon - 3.00 PM") {
      console.debug("selctedtime=" + userChoosenTime);
      newDate.setHours(12);
    }
    if ($("#timeSlot option:selected").text() == "3.00 PM - 6.00 PM") {
      console.debug("selctedtime=" + userChoosenTime);
      newDate.setHours(15);
    }
    Presto.user.order.chosenTimeSlot = userChoosenTime;
    console.debug("user selected time=" + Presto.user.order.chosenTimeSlot);
    Presto.user.order.userChoosenDate = userChoosenDate;
    console.debug("user selected date=" + Presto.user.order.userChoosenDate);
    var toIsoDate = newDate.toISOString();
    Presto.user.order.chosenTimeSlotValue = toIsoDate;
},
  
  populateOutletDetailTemplate: function(outlet){
    var data = {
      outlet: outlet,
      services: outlet.services,
      timeslots: ["11.00 AM", "12.00 PM", "1.00 PM", "2.00 PM", "3.00 PM", "4.00 PM", "5.00 PM", "6.00 PM"],
      merchant: Presto.merchant
    }

    Presto.merchant.catalog.outlet_id = outlet.id;
    if(Presto.user.loginStatus){
      data.user = Presto.user;
    }
    Presto.showTemplate('www/templates/outlet_detail.hbs', data);
  },
  
  fetchAndUpdateAuthToken: function() {
    console.debug("Fetching auth token");
    $.get(Presto.app.authTokenUrl, function(authToken, status, xhr) {
      Presto.app.authToken = authToken.token;
    }).fail(function(xhr, status, error) {
      // XXX : TODO : What should be done here?
    });
  },
  
  fetchAndUpdateOutletsData: function() {
    console.debug("Fetching and updating outlets data");
    Presto.fetchOutlets(function(outletsData) {
      Presto.merchant.outlets = outletsData;
      Presto.merchant.outletsFetched = true;
      Presto.merchant.outletsHash = Presto.utils.hashifyArray(outletsData, 'id');
      Presto.sortOutletsByCities(Presto.merchant.outlets);
      if(!Presto.locationDetectionTried && Presto.deviceLocationEnabled) {
        Presto.getCurrentLocation(function(currentLocation) {
          var sortedOutlets = Presto.sortOutletsByDistance(Presto.merchant.outlets, currentLocation);
          Presto.merchant.sortedOutlets = sortedOutlets;
          Presto.merchant.nearestOutlet = sortedOutlets[0];
        }, function(errorMessage) {
          console.debug("Returning outlets without sorting");
        });
      }else {
        if(Presto.user.currentLocation){
          var sortedOutlets = Presto.sortOutletsByDistance(Presto.merchant.outlets, Presto.user.currentLocation);
          Presto.merchant.sortedOutlets = sortedOutlets;
          Presto.merchant.nearestOutlet = sortedOutlets[0];
        }
      }   
    }, function(message) {
      console.error(message);
      console.error("Not updating outlets data");
      Presto.merchant.outletsFetched = false;
    });
  },
  
  sortOutletsByCities: function(outlets){
    Presto.merchant.outletCities = [];
    Presto.merchant.cityBasedOutlets = {};
    $(outlets).each(function(i, outlet){
      if(outlet.address && outlet.address.city){
        if(Presto.merchant.outletCities.indexOf(outlet.address.city) == -1){
          Presto.merchant.outletCities.push(outlet.address.city)
        }
        if(!Presto.merchant.cityBasedOutlets[outlet.address.city]){
          Presto.merchant.cityBasedOutlets[outlet.address.city] = [];
        }
        Presto.merchant.cityBasedOutlets[outlet.address.city].push(outlet);        
      }
    });
  },
  
  fetchNearByOutlets: function(successCallback, errorCallback, options) {
    Presto.fetchOutlets(function(outlets) {
    if(!Presto.locationDetectionTried && Presto.deviceLocationEnabled) {
        Presto.getCurrentLocation(function(currentLocation) {
          var sortedOutlets = Presto.sortOutletsByDistance(Presto.merchant.outlets, currentLocation);
          Presto.merchant.sortedOutlets = sortedOutlets;
          Presto.merchant.nearestOutlet = sortedOutlets[0];
        successCallback(sortedOutlets, true);
        }, function(errorMessage) {
          console.debug("Returning outlets without sorting");
        successCallback(outlets, false);
        });
    }else {
      if(Presto.user.currentLocation){
              var sortedOutlets = Presto.sortOutletsByDistance(Presto.merchant.outlets, Presto.user.currentLocation);
              Presto.merchant.sortedOutlets = sortedOutlets;
              Presto.merchant.nearestOutlet = sortedOutlets[0];
          successCallback(sortedOutlets, true);
      }else {
        successCallback(outlets, false);
      }
    }
    }, function(errorMessage) {
      errorCallback(errorMessage);
    });
  },
  
  fetchNearestOutlet: function(successCallback, errorCallback) {
    Presto.fetchNearByOutlets(function(outletsData, sortedOrNot) {
      console.debug("Got near by outlets. Sending first one as nearest outlet");
      Presto.merchant.nearestOutlet = outletsData[0];
      Presto.merchant.nearestOutletFetchTime = new Date();
      successCallback(outletsData[0], sortedOrNot);
    }, function(errorMessage) {
      errorCallback(errorMessage);
    });
  },
  
  fetchOutlets: function(successCallback, errorCallback) {
    /*
     * XXX : TODO : 
     * Add some intelligence here to see if we can avoid fetching the outlet list from server.
     * Use the existing data and the timestamp on the last fetch of that data to decide.
     */
    console.debug("Fetching outlets data from server");
  
    if(Presto.merchant.outlets && Presto.merchant.outlets.length > 0) {
      successCallback(Presto.merchant.outlets);
    }else {
      $.get(Presto.merchant.outletsUrl, function(outletsData, status, xhr) {
        console.debug("Outlets fetched successfully. No of outlets = " + outletsData.length);
        Presto.merchant.outlets = outletsData;
        Presto.merchant.outletsHash = Presto.utils.hashifyArray(outletsData, 'id');
        Presto.merchant.outletsFetched = true;
        Presto.merchant.outletsFetchTime = new Date();
        Presto.sortOutletsByCities(Presto.merchant.outlets);
        successCallback(outletsData);
      }).fail(function(xhr, status, error) {
        console.error("error fetching outlets data. status = " + status + "\nerror = " + error + "\nxhr.responseText = " + 
        xhr.responseText + "\nxhr.code = " + xhr.code);
        Presto.merchant.outletsFetched = false;
        errorCallback("Could not fetch the outlets. Please check your internet connection and try again");
      });
    }
  },
  
  getCurrentLocation: function(successCallback, errorCallback, showError) {
    showError = showError === undefined ? false : true
    if ("geolocation" in navigator) {
      /* Get location  and proceed */
      console.debug("navigator available. Try to get the current location");
      navigator.geolocation.getCurrentPosition(function(currentLocation) {
        console.debug("Got current location successfuly. " + JSON.stringify(currentLocation));
        Presto.user.currentLocation = {latitude: currentLocation.coords.latitude, longitude: currentLocation.coords.longitude};
        Presto.user.lastLocationFetchTime = new Date(currentLocation.timestamp);
        successCallback(Presto.user.currentLocation);
      }, function(locationError) {
        var message = "Location detection failed.";
        switch(locationError.code) {
          case locationError.PERMISSION_DENIED:
            console.debug("Permission denied to get current location");
            message = Presto.app.name + " was not given permission to access your location.";
            break;
          case locationError.POSITION_UNAVAILABLE:
            console.debug("Location is unavailable");
            message = "Your current location is unavailable.";
            break;
          case locationError.TIMEOUT:
            console.debug("Location detection timed out");
            message = "Detecting your location is taking very long.";
            break;
        }
        if (showError) {
          Presto.showAlert(message);
        }
        errorCallback(message)
      }, {
        enableHighAccuracy: false,
        timeout: 5000,
        maximumAge: 900000
      });
    } else {
      console.debug("navigator is not available. Could not detect the current location.")
      errorCallack("Could not detect your current location.");
    }
  },
  
  sortOutletsByDistance: function(outlets, location) {
    sortedOutlets = geolib.orderByDistance(location, outlets);
    for (var i in sortedOutlets) {
      Presto.merchant.sortedOutlets[i] = Presto.merchant.outlets[sortedOutlets[i].key];
      Presto.merchant.sortedOutlets[i].distance = sortedOutlets[i].distance;
    Presto.merchant.sortedOutlets[i].distance_km = geolib.convertUnit('km',sortedOutlets[i].distance);
    }
    return Presto.merchant.sortedOutlets;
  },
  
  fetchAndShowOutlets: function(showCatalogForOutlet) {
    console.debug("Fetching and showing nearby outlets");
    $.blockUI(Presto.getThrobberData("Searching for stores closest to you"));
    Presto.merchant.outletsSorted = false;
    Presto.fetchNearByOutlets(function(outletsData, sortedOrNot) {
      console.debug("Successfully fetched the nearby outlets list");
      Presto.merchant.outletsSorted = sortedOrNot;
      Presto.showOutlets(showCatalogForOutlet);
      $.unblockUI();
    }, function(errorMessage) {
      $.unblockUI();
      console.debug("Could not get nearby outlets. Error : " + errorMessage);
      Presto.showAlert("Could not fetch the outlets. Please check your internet connection and try again");
      Presto.merchant.outletsFetched = false;
    });
    /*
    if (Presto.merchant.outletsFetched) {
      Presto.sortAndShowOutlets(showCatalogForOutlet);
    } else {
      console.debug("Fetching outlets data from server");
      $.blockUI(Presto.getThrobberData("Fetching the stores closest to you"));
      $.get(Presto.merchant.outletsUrl, function(outletsData, status, xhr) {
        $.unblockUI();
        Presto.merchant.outlets = outletsData;
        Presto.merchant.outletsFetched = true;
        Presto.sortAndShowOutlets(showCatalogForOutlet);
      }).fail(function(xhr, status, error) {
        $.unblockUI();
        console.error("error fetching outlets data. status = " + status + "\nerror = " + error + "\nxhr.responseText = " + xhr.responseText + "\nxhr.code = " + xhr.code);
        Presto.showAlert("Could not fetch the outlets. Please check your internet connection and try again");
        Presto.merchant.outletsFetched = false;
      });
    }
    */
  },
  
  sortOutletsByLocation: function(location) {
    sortedOutlets = geolib.orderByDistance(location, Presto.merchant.outlets);
    for (var i in sortedOutlets) {
      Presto.merchant.sortedOutlets[i] = Presto.merchant.outlets[sortedOutlets[i].key];
      Presto.merchant.sortedOutlets[i].distance = (sortedOutlets[i].distance / 1000);
    }
  },
  
  /*
  */
  sortAndShowOutlets: function(showCatalogForOutlet) {
    if ("geolocation" in navigator) {
      /* Get location  and proceed */
      $.blockUI(Presto.getThrobberData("Searching for stores closest to you"));
      navigator.geolocation.getCurrentPosition(function(currentLocation) {
        $.unblockUI();
        console.debug("Got current location successfuly. " + JSON.stringify(currentLocation));
        Presto.user.currentLocation = {latitude: currentLocation.coords.latitude, longitude: currentLocation.coords.longitude};
        Presto.user.lastLocationFetchTime = new Date(currentLocation.timestamp);
        Presto.sortOutletsByLocation(Presto.user.currentLocation);
        Presto.showOutlets(showCatalogForOutlet);
      }, function(locationError) {
        $.unblockUI();
        console.debug("Could not get current location");
        switch(locationError.code) {
          case locationError.PERMISSION_DENIED:
            console.debug("Permission denied to get current location");
            Presto.showAlert(Presto.app.name + " was not given permission to access your location. Stores cannot be shown based on their distances");
            break;
          case locationError.POSITION_UNAVAILABLE:
            console.debug("Location is unavailable");
            Presto.showAlert("Your current location is unavailable. Stores cannot be shown based on their distances");
            break;
          case locationError.TIMEOUT:
            console.debug("Location detection timed out");
            Presto.showAlert("Detecting your location is taking very long. Stores cannot be shown based on their distances");
            break;
        }
        Presto.showOutlets(showCatalogForOutlet);
      }, {
        enableHighAccuracy: false,
        timeout: 5000,
        maximumAge: 900000
      });
    } else {
      Presto.showOutlets();
    }
  },
  
  showOutlets : function(showCatalogForOutlet) {
    console.debug("Showing outlets");
    var outletsData = {
      outlets: Presto.merchant.outlets,
      showCatalogForOutlet: 'false'
    };
    if (Presto.merchant.sortedOutlets.length > 0) {
      outletsData.outlets = Presto.merchant.sortedOutlets;
    }
    
    if (showCatalogForOutlet != null && showCatalogForOutlet) {
      outletsData.showCatalogForOutlet = 'true';
    }
    console.debug("No of Outlets = " + outletsData.outlets.length.toString());
    Presto.showTemplate('www/templates/outlets.hbs', outletsData);
  },
  
  showOutletsOnMap : function() {
    try {
      console.debug("Showing outlets on a map");
      var container = document.getElementById("presto-map-container");
      var outlets = Presto.merchant.outlets;
      if (Presto.merchant.outletsSorted) {
        outlets = Presto.merchant.sortedOutlets;
      }
      var mapCenter = {
        latitude : outlets[0].address.location[0],
        longitude : outlets[0].address.location[1]
      };
      if (Presto.user.currentLocation) {
        mapCenter = {
          latitude : Presto.user.currentLocation.latitude,
          longitude : Presto.user.currentLocation.longitude
        };
      }
      var mapOptions = {
        center : new google.maps.LatLng(mapCenter.latitude, mapCenter.longitude),
        zoom : 11
      };
      var map = new google.maps.Map(container, mapOptions);
      var markers = [];
      var infoWindows = [];
      for(var i in outlets) {
        var outlet = outlets[i];
      
        infoWindows[i] = new google.maps.InfoWindow({
          content : Presto.templates["www/templates/outlet_gmap_infowindow.hbs"](outlet)
        });
      
        markers[i] = new google.maps.Marker({
          map : map,
          animation : google.maps.Animation.DROP,
          title : outlet.name,
          position : new google.maps.LatLng(outlet.address.location[0], outlet.address.location[1])
        });
        
        Presto.wireUpMarkerAndInfoWindow(markers[i], infoWindows[i]);
      }
    } catch (e) {
      console.error("Caught exception while showing map with markers : " + e.message);
    }
  },
  
  wireUpMarkerAndInfoWindow : function(marker, infoWindow) {
    console.debug("Adding an event listener for " + marker.title);
    google.maps.event.addListener(marker, 'click', function() {
    console.debug("Marker clicked " + marker.title);
    console.debug("Showing infoWindow " + infoWindow.content);
    infoWindow.open(marker.get('map'), marker);
    });
  },
  
  showCurrentCatalog: function(event) {
    if (Presto.merchant.nearestOutlet && !Presto.merchant.hasCommonCatalog) {
      console.debug("Nearest outlet already fetched. Showing catalog for outlet with id : " + Presto.merchant.nearestOutlet.id)
      var templateName = $(event.currentTarget).attr("data-template");
      Presto.fetchAndShowCatalogForOutlet(templateName, Presto.merchant.nearestOutlet.id);
    } else {
      console.debug("Nearest outlet not available. Fetching nearest outlet and showing catalog for that outlet");
      Presto.showCatalogForNearestOutlet(event);
    }
  },
  
  showCurrentServicesCatalog: function(event){
    var templateName = $(event.currentTarget).attr("data-template");
    if (Presto.merchant.nearestOutlet) {  
      Presto.fetchAndShowServicesCatalogForOutlet(templateName, Presto.merchant.nearestOutlet.id);
    }else {
      $.blockUI(Presto.getThrobberData("Searching for the nearest outlet"));
      Presto.fetchNearestOutlet(function(nearestOutlet) {
        $.unblockUI();
        Presto.merchant.nearestOutlet = nearestOutlet;
        Presto.fetchAndShowServicesCatalogForOutlet(templateName, Presto.merchant.nearestOutlet.id);
      }, function(errorMessage){
        console.debug("Could not fetch services for nearest store. Error : " + errorMessage);
        Presto.showAlert(errorMessage)
        $.unblockUI();
      });
    }
  },
  
  fetchAndShowServicesCatalogForOutlet: function(templateName, outletId){
    Presto.fetchServicesCatalogForOutlet(outletId, function(){
      Presto.showServicesCatalog(templateName);
    });
  },
  
  fetchServicesCatalogForOutlet: function(outletId, successCallback){
    var catalogUrl = "http://" + Presto.app.host + "/catalog.json?type=services&";
    if(Presto.merchant.hasCityBasedCatalog){
      catalogUrl += "filter=" + Presto.merchant.outletsHash[outletId].address.city + "&merchant_id=" + Presto.merchant.id;
    }else if(Presto.merchant.hasCommonCatalog){
      catalogUrl += "merchant_id=" + Presto.merchant.id;
    }else {
      catalogUrl += "outlet_id=" + outletId;
    }
    $.blockUI(Presto.getThrobberData("Fetching services catalog"));
    $.get(catalogUrl, function(catalogData, status, xhr) {
      $.unblockUI();
      console.debug("catalogData = \n" + JSON.stringify(catalogData));
      Presto.merchant.servicesCatalog = catalogData;
      Presto.merchant.servicesCatalogFetched = true;
      Presto.merchant.servicesCatalogFetchTime = new Date();      
      Presto.populateSidebarView();
      successCallback();
    }).fail(function(xhr, status, error) {
      $.unblockUI();
      console.error("error fetching catalog data. status = " + status + "\nerror = " + error + "\nxhr.responseText = " + xhr.responseText + "\nxhr.code = " + xhr.code);
      Presto.showAlert("Could not fetch the services catalog. Please check your internet connection and try again");
    });
  },
  
  showCatalogForNearestOutlet: function(event) {
    console.debug("Showing catalog for the nearest outlet");
    if(Presto.merchant.hasCommonCatalog){
        Presto.merchant.catalogFetched = false;
      var templateName = $(event.currentTarget).attr("data-template");
        Presto.fetchAndShowCatalogForMerchant(templateName, Presto.merchant.id);
    }else{
      $.blockUI(Presto.getThrobberData("Searching for the nearest outlet"));
      Presto.fetchNearestOutlet(function(nearestOutlet) {
      $.unblockUI();
      Presto.merchant.catalogFetched = false;
      var templateName = $(event.currentTarget).attr("data-template");
      Presto.fetchAndShowCatalogForOutlet(templateName,nearestOutlet.id);
      }, function(errorMessage) {
      console.debug("Could not fetch catalog for nearest store. Error : " + errorMessage);
      Presto.showAlert(errorMessage)
      $.unblockUI();
      });
    }
  },

  populateCategoryBar: function() {
    if (Presto.merchant.categoryBarWithImages) {
      Presto.populateCategoryBarWithImages();
    }
    if (Presto.merchant.categoryBarWithoutImages) {
      Presto.populateCategoryBarWithoutImages();
    }
  },

  populateCategoryBarWithImages: function() {
    if($("#bottom-bar").length > 0){
      $("#bottom-bar").html("");
      $(Presto.merchant.catalog.categories).each(function(i, category){
        var cat_string = '<a href="#" class="categoryItem" data-categoryId="'+category.id+'" data-categoryName="'+category.name+'"><img src="'+category.pic_url+'" alt="" style="max-width: 40px;max-height: 40px;height: auto;width: auto;margin-left: 5px;margin-right: 5px;margin-top: 5px;"></a>';
        $("#bottom-bar").append(cat_string); 
      });
    }
  },


  populateCategoryBarWithoutImages: function() {
    if($("#bottom-bar").length > 0){
      $("#bottom-bar").html("");
      $(Presto.merchant.catalog.categories).each(function(i, category){
        var cat_string = '<a href="#" class="categoryItem" data-categoryId="'+category.id+'" data-categoryName="'+category.name+'" style="display: inline;"><p style="display: inline;margin-left: 5px;" class="bottom-bar-name">' +category.name+ '</p></a>';
        $("#bottom-bar").append(cat_string);
      });
    }
  },
  
  fetchCatalogAndShowFirstCategoryForOutlet: function(templateName, outletId) {    
    var catalogUrl = "http://" + Presto.app.host + "/catalog.json";
    if(Presto.merchant.hasCityBasedCatalog){
      catalogUrl += "?filter=" + Presto.merchant.outletsHash[outletId].address.city + "&merchant_id=" + Presto.merchant.id;
    }else if(Presto.merchant.hasCommonCatalog){
      catalogUrl += "?merchant_id=" + Presto.merchant.id;
      if(Presto.merchant.commonCatalogFilterEnabled) {
        catalogUrl += "&filter=" + Presto.merchant.commonCatalogFilter;
      }
    }else {
      Presto.resetOrder();
      catalogUrl += "?outlet_id=" + outletId;
    }
      console.debug("Fetching catalog with url : " + catalogUrl);
      var throbberData = "";
      if(throbberData==""){
        $.blockUI(Presto.getThrobberData("Fetching the catalogue"));
      }else{
        $.blockUI(Presto.getThrobberData(""));
      }
      $.get(catalogUrl, function(catalogData, status, xhr) {
        $.unblockUI();
        console.debug("catalogData = \n" + JSON.stringify(catalogData));
        Presto.merchant.catalog = catalogData;
        if(Presto.merchant.hasCategoryBar) {
          Presto.populateCategoryBar();
        }
        Presto.merchant.catalogFetched = true;
        Presto.merchant.catalogFetchTime = new Date();
        Presto.merchant.outletsCatalog[outletId] = catalogData;
    Presto.merchant.catalog.outlet_id = outletId;
        Presto.populateSidebarView();
        Presto.resetOrder();
        Presto.setCatalogItemAddedCount();
    if(!templateName){
      templateName = "category.hbs"
    }
    var categoryId = Presto.merchant.catalog.categories[0].id;
    var items = Presto.merchant.catalog.categoryItems[categoryId].items;
    var remaining_items = [];
    var sold_out_items = [];
    $(items).each(function(i, item){
      if(item.sold_out || item.stock_count == 0) {
        sold_out_items.push(item)
      }else {
        remaining_items.push(item)
      }
    });
    Presto.merchant.catalog.categoryItems[categoryId].items = remaining_items.concat(sold_out_items);
    
    Presto.showTemplate('www/templates/' + templateName, Presto.merchant.catalog.categoryItems[categoryId]);
      }).fail(function(xhr, status, error) {
        $.unblockUI();
        console.error("error fetching catalog data. status = " + status + "\nerror = " + error + "\nxhr.responseText = " + xhr.responseText + "\nxhr.code = " + xhr.code);
        Presto.showAlert("Could not fetch the catalog. Please check your internet connection and try again");
      });

  },


  fetchAndShowCatalogForMerchant: function(templateName, merchantId) {
    var catalogUrl = "http://" + Presto.app.host + "/catalog.json?merchant_id=" + merchantId;
    console.debug("Fetching catalog with url : " + catalogUrl);
    $.blockUI(Presto.getThrobberData("Fetching the catalogue"));
    $.get(catalogUrl, function(catalogData, status, xhr) {
      $.unblockUI();
      console.debug("catalogData = \n" + JSON.stringify(catalogData));
      Presto.merchant.catalog = catalogData;
      if(Presto.merchant.hasCategoryBar) {
        Presto.populateCategoryBar();
      }
      Presto.merchant.catalogFetched = true;
      Presto.merchant.catalogFetchTime = new Date();
      Presto.showCatalog(templateName);
      Presto.populateSidebarView();
      if(Presto.merchant.nearestOutlet && Presto.outletChosen){
        Presto.merchant.catalog.outlet_id = Presto.merchant.nearestOutlet.id;
      }
    }).fail(function(xhr, status, error) {
      $.unblockUI();
      console.error("error fetching catalog data. status = " + status + "\nerror = " + error + "\nxhr.responseText = " + xhr.responseText + "\nxhr.code = " + xhr.code);
      Presto.showAlert("Could not fetch the catalog. Please check your internet connection and try again");
    });
  },
  
  fetchAndShowCatalogForOutlet: function(templateName, outletId) {
    /* XXX : TODO : Srirang : Disabling this check so that we always refresh the catalog
     * This is specifically required when the user does a "Clear Cart" so that we reset the flags about items
     * having been added to the cart.
     *
     * This is somewhat inefficient, but will do for now.
     */
    
    if (false && Presto.merchant.outletsCatalog[outletId]) {
      console.debug("Catalog already fetched for outlet with id " + outletId + ". Showing it");
      Presto.merchant.catalog = Presto.merchant.outletsCatalog[outletId];
      Presto.showCatalog(templateName);
      Presto.populateSidebarView();
    } else {
    var catalogUrl = "http://" + Presto.app.host + "/catalog.json";
    if(Presto.merchant.has_common_product_catalog){
      catalogUrl += "?type=products" + "&merchant_id=" + Presto.merchant.id;
    }
    else if(Presto.merchant.hasCityBasedCatalog){
      catalogUrl += "?filter=" + Presto.merchant.outletsHash[outletId].address.city + "&merchant_id=" + Presto.merchant.id;
    }else if(Presto.merchant.hasCommonCatalog){
      catalogUrl += "?merchant_id=" + Presto.merchant.id;
    }else {
      Presto.resetOrder();
      catalogUrl += "?outlet_id=" + outletId;
    }
      console.debug("Fetching catalog with url : " + catalogUrl);
      $.blockUI(Presto.getThrobberData("Fetching the catalogue"));
      $.get(catalogUrl, function(catalogData, status, xhr) {
        $.unblockUI();
        console.debug("catalogData = \n" + JSON.stringify(catalogData));
        Presto.merchant.catalog = catalogData;
        if(Presto.merchant.hasCategoryBar) {
          Presto.populateCategoryBar();
        }
        Presto.merchant.catalogFetched = true;
        Presto.merchant.catalogFetchTime = new Date();
        Presto.merchant.outletsCatalog[outletId] = catalogData;
        Presto.merchant.catalog.outlet_id = outletId;
        Presto.showCatalog(templateName);
        Presto.populateSidebarView();
        Presto.setCatalogItemAddedCount();
      }).fail(function(xhr, status, error) {
        $.unblockUI();
        console.error("error fetching catalog data. status = " + status + "\nerror = " + error + "\nxhr.responseText = " + xhr.responseText + "\nxhr.code = " + xhr.code);
        Presto.showAlert("Could not fetch the catalog. Please check your internet connection and try again");
      });
    }
  },
  
  showCatalog: function(templateName) {
    console.debug("Showing current catalog");
    var catalogData = {
      catalog: Presto.merchant.catalog,
      outlet: Presto.merchant.outletsHash[Presto.merchant.catalog.outlet_id]
    };
    if(!templateName){
      templateName = "category_list.hbs";
    }
    
    if(templateName == "category.hbs") {
      var categoryId = Presto.merchant.catalog.categories[0].id;
      Presto.showTemplate('www/templates/' + templateName, Presto.merchant.catalog.categoryItems[categoryId]);
    }else {
      Presto.showTemplate('www/templates/' + templateName, catalogData);
    }
     
  },
  
  showServicesCatalog: function(templateName) {
    console.debug("Showing current catalog");
    var catalogData = Presto.merchant.servicesCatalog;
    if(!templateName){
      templateName = "services_catalog.hbs";
    }
    Presto.showTemplate('www/templates/' + templateName, catalogData);
  },
  
  showCategoryItems: function(event) {
    var categoryId = $(event.currentTarget).attr("data-categoryId");
    var categoryName = $(event.currentTarget).attr("data-categoryName");
    console.debug("Clicked on category : " + categoryName);
  $(".sidePanelCategory").removeClass("active");
  $("#sidePanelCategory_"+categoryId).addClass("active");
  var templateName = $(event.currentTarget).attr("data-template");
  if(!templateName){
    templateName = "category.hbs"
  }
    Presto.showTemplate('www/templates/' + templateName, Presto.merchant.catalog.categoryItems[categoryId]);
  },
  
  showServiceCategoryItems: function(event){
    var categoryId = $(event.currentTarget).attr("data-categoryId");
    var categoryName = $(event.currentTarget).attr("data-categoryName");
    console.debug("Clicked on category : " + categoryName);
    $(".sidePanelCategory").removeClass("active");
    $("#sidePanelCategory_"+categoryId).addClass("active");
    var templateName = $(event.currentTarget).attr("data-template");
    if(!templateName){
      templateName = "service_category.hbs"
    }
    Presto.showTemplate('www/templates/' + templateName, Presto.merchant.servicesCatalog.categoryServices[categoryId]);
  },
  
  findItemInCategory: function(itemId, categoryId, variationId) {
    var currentItem = null;
    var items = [];
    if(categoryId == ""){
      items = Presto.merchant.catalog.items;
    }else{
      items = Presto.merchant.catalog.categoryItems[categoryId].items;
    }
    for (var i in items) {
      if (items[i].id == itemId) {
        currentItem = items[i];
        break;
      }
    }

    if(variationId && variationId != ""){
      var currentVariation = null;
      $(currentItem.variations).each(function(i, variation){
        if(variation.id == variationId){
          currentVariation = variation;
        }
      });
      tempVariation = new Object(currentVariation);
      outerVariationKeys = []
      outerVariationKeys.push({"type": currentVariation.type, "value": currentVariation.value});
      while(tempVariation.outer_variation_id) {
        $(currentItem.variations).each(function(i, variation){
          if(variation.id == tempVariation.outer_variation_id){
            tempVariation = variation;
          }
        });
        outerVariationKeys.push({"type": tempVariation.type, "value": tempVariation.value});
      }

      currentVariation.other_data["outer_variations"] = outerVariationKeys;
      if(!currentVariation.pic_url || currentVariation.pic_url == ""){
        currentVariation.pic_url = currentItem.pic_url;
      }
      currentItem = currentVariation;
    }

    return currentItem;
  },
  
  showItem: function(itemId, categoryId) {
    console.debug("Showing item with itemId " + itemId);
    if ((Presto.merchant.catalog.categoryItems[categoryId] && Presto.merchant.catalog.categoryItems[categoryId].items instanceof Array) || categoryId == "") {
      var currentItem = Presto.findItemInCategory(itemId, categoryId);
      
      if (currentItem) {
        Presto.showTemplate('www/templates/item.hbs', currentItem);
      } else {
        console.debug("Specified item not found in the category while viewing. itemId = " + itemId + " categoryId = " + categoryId);
      }
    } else {
      console.debug("Attempted to view unknown item. categoryId = " + categoryId + " itemId = " + itemId);
    }
  },
  
  addItemtoOrder: function(itemId, categoryId, variationId) {
    if(!variationId){
      variationId = "";
    }
    console.debug("Adding an item with itemId " + itemId);
    if ((Presto.merchant.catalog.categoryItems[categoryId] && Presto.merchant.catalog.categoryItems[categoryId].items instanceof Array) || categoryId == "") {
      var currentItem = Presto.findItemInCategory(itemId, categoryId, variationId);
    var minQuantity = 1;
    if(currentItem.other_data && currentItem.other_data["min_quantity"]){
      minQuantity = currentItem.other_data["min_quantity"];
    }
    if(Presto.merchant.inventory_enabled){
      if(currentItem.stock_count && currentItem.addedCount >= currentItem.stock_count){
       var unit_label = "unit";
       if(currentItem.stock_count > 1){
         unit_label = "units";
       }
      Presto.showAlert("We have only " + currentItem.stock_count + " " + unit_label + " left!");
      return;
      }
    }
      if (currentItem) {
        if (Presto.user.order.lineItems[itemId + variationId]) {
          Presto.user.order.lineItems[itemId + variationId].quantity++;
          Presto.user.order.noOfItems++;
          Presto.user.order.totalPrice+= currentItem.price.total_price;
          Presto.user.order.basePrice+= currentItem.price.base_price;
          Presto.user.order.tax+= currentItem.price.tax;
          Presto.user.order.serviceTax+= currentItem.price.service_tax;
          Presto.user.order.vatAmount+= currentItem.price.vat_amount;
          if(currentItem.price.packing_charge){
            Presto.user.order.packagingAmount+= currentItem.price.packing_charge;
          }
        } else {
          Presto.user.order.lineItems[itemId + variationId] = {
            categoryId: categoryId,
            itemId: itemId,
            name: currentItem.name,
            summary: currentItem.summary,
            description: currentItem.description,
            quantity: minQuantity,
            totalPrice: currentItem.price.total_price,
            basePrice: currentItem.price.base_price,
            packagingPrice: currentItem.price.packing_charge,
            tax: currentItem.price.tax,
            serviceTax: currentItem.price.service_tax,
            vatAmount: currentItem.price.vat_amount,
            pic_url: currentItem.pic_url,
            variationId: variationId,
            other_data: currentItem.other_data
          };
      
          Presto.user.order.noOfItems+=minQuantity;
          Presto.user.order.totalPrice+= currentItem.price.total_price * minQuantity;
          Presto.user.order.basePrice+= currentItem.price.base_price * minQuantity;
          Presto.user.order.tax+= currentItem.price.tax * minQuantity;
          Presto.user.order.serviceTax+= currentItem.price.service_tax * minQuantity;
          Presto.user.order.vatAmount+= currentItem.price.vat_amount * minQuantity;
          if(currentItem.price.packing_charge){
            Presto.user.order.packagingAmount+= currentItem.price.packing_charge * minQuantity;
          }
        }
        currentItem.addedCount = Presto.user.order.lineItems[itemId + variationId].quantity;
        $('#' + itemId + variationId + '-count').removeClass('hidden');
        $('#' + itemId + variationId + '-count').html(currentItem.addedCount);
        if(Presto.merchant.hideRemoveControlOnEmptyCount) {
          $('#' + itemId + variationId + '-count').closest("div.cart-controls").find(".removeItem").removeClass("hidden");
        } else {
          $('#' + itemId + variationId + '-count').closest("div").find(".removeItem").addClass("hidden");
        }
        Presto.user.order.billAmount = Presto.user.order.totalPrice + Presto.user.order.tax + Presto.user.order.packagingAmount;
        if(Presto.merchant.deliveryCharges){
          Presto.user.order.billAmount += parseInt(Presto.merchant.deliveryCharges);
          Presto.user.order.deliveryCharges = Presto.merchant.deliveryCharges;
        }
        $('#noOfItemsCount').html(Presto.user.order.noOfItems);
        $('#itemsText').html(Presto.utils.itemOrItemsString());
        $('#totalAmountInCart').html(Presto.user.order.basePrice);
        currentItem.addedClass = "added";
        $("#"+itemId+variationId).addClass("added");
        Presto.animateCart();
      } else {
        console.debug("Specified item not found in the category while adding. itemId = " + itemId + " categoryId = " + categoryId);
      }
    } else {
      console.debug("Attempted to add unknown item. categoryId = " + categoryId + " itemId = " + itemId);
    }
  },
  
  removeItemFromOrder: function(itemId, categoryId, variationId) {
    if(!variationId){
      variationId = "";
    }
    console.debug("Removing an item with itemId " + itemId);
    if ((Presto.merchant.catalog.categoryItems[categoryId] && Presto.merchant.catalog.categoryItems[categoryId].items instanceof Array) || categoryId == "") {
      var currentItem = Presto.findItemInCategory(itemId, categoryId, variationId);
      
      if (currentItem) {
        var minQuantity = 1;
        if(currentItem.other_data && currentItem.other_data["min_quantity"]){
          minQuantity = currentItem.other_data["min_quantity"];
        }
        if (Presto.user.order.lineItems[itemId + variationId]) {
          if (Presto.user.order.lineItems[itemId + variationId].quantity == minQuantity) {
            delete Presto.user.order.lineItems[itemId + variationId];
            currentItem.addedClass = "";
            currentItem.addedCount = 0;
            $("#"+itemId).removeClass("added");
            //$('#' + itemId + '-count').addClass('hidden');
            if(Presto.merchant.hideRemoveControlOnEmptyCount) {
              $('#' + itemId + variationId + '-count').addClass('hidden');
              $('#' + itemId + variationId + '-count').closest("div.cart-controls").find(".removeItem").addClass("hidden");
            } else {
              $('#' + itemId + variationId + '-count').html('0');
              $('#' + itemId + variationId + '-count').closest("div").find(".removeItem").addClass("hidden");
            }
            Presto.user.order.noOfItems-= minQuantity;
            Presto.user.order.totalPrice-= currentItem.price.total_price * minQuantity;
            Presto.user.order.basePrice-= currentItem.price.base_price * minQuantity;
            if(currentItem.price.packing_charge){
              Presto.user.order.packagingAmount-= currentItem.price.packing_charge * minQuantity;
            }
            Presto.user.order.tax-= currentItem.price.tax * minQuantity;
            Presto.user.order.serviceTax-= currentItem.price.service_tax * minQuantity;
            Presto.user.order.vatAmount-= currentItem.price.vat_amount * minQuantity;
          } else {
            Presto.user.order.lineItems[itemId + variationId].quantity--;
            currentItem.addedCount = Presto.user.order.lineItems[itemId + variationId].quantity;
            $('#' + itemId + variationId + '-count').html(Presto.user.order.lineItems[itemId + variationId].quantity);
            Presto.user.order.noOfItems--;  
            Presto.user.order.totalPrice-= currentItem.price.total_price;
            Presto.user.order.basePrice-= currentItem.price.base_price;
            if(currentItem.price.packing_charge){
              Presto.user.order.packagingAmount-= currentItem.price.packing_charge;
            }
            Presto.user.order.tax-= currentItem.price.tax;
          Presto.user.order.serviceTax-= currentItem.price.service_tax;
          Presto.user.order.vatAmount-= currentItem.price.vat_amount;
          }

          
          Presto.user.order.billAmount = Presto.user.order.totalPrice + Presto.user.order.tax + Presto.user.order.packagingAmount;
          if(Presto.merchant.deliveryCharges){
            Presto.user.order.billAmount += parseInt(Presto.merchant.deliveryCharges);
            Presto.user.order.deliveryCharges = Presto.merchant.deliveryCharges;
          }
          $('#noOfItemsCount').html(Presto.user.order.noOfItems);
          $('#itemsText').html(Presto.utils.itemOrItemsString());
          $('#totalAmountInCart').html(Presto.user.order.basePrice);
          Presto.animateCart();
          } else {
            console.debug("Specified item not present in the order. Not doing anything");
          }
        } else {
          console.debug("Specified item not found in the category while removing. itemId = " + itemId + " categoryId = " + categoryId);
        }
      } else {
      console.debug("Attempted to remove unknown item. categoryId = " + categoryId + " itemId = " + itemId);
    }
  },
  
  animateCart: function() {
    $("#noOfItems").addClass("highlight").delay(4500).queue(function() {
      $(this).removeClass("highlight");
      $(this).dequeue();
    });
  },

  showOrderSummary: function() {
    if (Presto.user.order.noOfItems > 0) {
      if (Presto.merchant.needUserDetailsInOrderSummary) {
        var templateData = {
          user: Presto.user,
          order: Presto.user.order
        };
        Presto.showTemplate('www/templates/order_summary.hbs', templateData);
        return;
      }
      if(Presto.merchant.minimumOrderValue) {
        if(Presto.user.order.billAmount > Presto.merchant.minimumOrderValue) {
          console.debug("Showing order summary");
          Presto.showTemplate('www/templates/order_summary.hbs', Presto.user.order);
        } else {
          PrestoAnalytics.trackEvent("buttonClick", "Checkout Button - Insufficient Order");
          var cartAmountErrorMessage = Presto.merchant.minimumOrderValueMessage;
          if(cartAmountErrorMessage=="") {
            Presto.showAlert("Please add items to order before checking out.");
            return;
          } else {
            Presto.showAlert(cartAmountErrorMessage + ". Your current bill amount is Rs " + Presto.user.order.billAmount);
            return;
          }
        }
      } else {
         console.debug("Showing order summary");
         if (Presto.merchant.needUserDetailsInOrderSummary) {
           var templateData = {
             user: Presto.user,
             order: Presto.user.order
           };
           Presto.showTemplate('www/templates/order_summary.hbs', templateData);
         }else {
           Presto.showTemplate('www/templates/order_summary.hbs', Presto.user.order);
         }
      }
    } else {
      console.debug("Cart clicked without anything in order. Showing alert to user");
      Presto.showAlert("Please add items to order before checking out.");
    }
  },
  
  checkoutOrder: function() {
    if(Presto.user.order.noOfItems <= 0){
      console.debug("Cart clicked without anything in order. Showing alert to user");
      Presto.showAlert("Please add items to order before checking out.");
      return;
    }
    if(Presto.merchant.main_menu_item_required){
      has_one_main_item = false;
      $.each(Presto.user.order.lineItems, function(itemId, lineItem){
        if(!lineItem.categoryId || lineItem.categoryId == ""){
          has_one_main_item = true;
          return false;
        }
      });
      if(!has_one_main_item){
        Presto.showAlert("Please add at least one main menu item");
        var templateData = {
            catalog: Presto.merchant.catalog,
            outlet: Presto.merchant.outletsHash[Presto.merchant.catalog.outlet_id]
          };
        Presto.showTemplate("www/templates/category_list.hbs", templateData);
        return;
      }
    }
    
    if(Presto.app.discount_enabled){
      $.blockUI(Presto.getThrobberData("Checking for discounts"));
      orderData = Presto.buildOrderData();
      
      postData = {
        authenticity_token: Presto.app.authToken,
        order: orderData
      };
      
      var discountUrl = "http://" + Presto.app.host + "/orders/check_discount.json";
      postData.merchant_id = Presto.merchant.id;
      postData.app_id = Presto.merchant.app_id;
      console.debug("Sending POST request to " + discountUrl + " with data = \n" + JSON.stringify(postData));
      
      $.ajax(discountUrl, {
        type: 'POST',
        data: JSON.stringify(postData),
        contentType: 'application/json; charset=utf-8',
        //dataType: 'json',
        success: function(responseData, status, xhr) {
          $.unblockUI();
          if(responseData.discount_value && responseData.discount_value > 0){
            Presto.user.order.discount_value = responseData.discount_value;
            Presto.user.order.discounted_bill_amount = responseData.discount_bill;
          }else {
            Presto.user.order.discount_value = 0;
            Presto.user.order.discounted_bill_amount = Presto.user.order.billAmount;
          }
          if(responseData.discount_available){
          Presto.user.order.discount_message = responseData.discount_message;
          Presto.use.order.discount_available = responseData.discount_available;
          }
          Presto.showCheckoutScreen();
        },
        error: function(xhr, status, reason){
          $.unblockUI();
          Presto.user.order.discount_value = 0;
          Presto.user.order.discounted_bill_amount = Presto.user.order.billAmount;
          Presto.showCheckoutScreen();
        }
      });
    }else {
      Presto.showCheckoutScreen();
    }
    
  },
  
  showCheckoutScreen: function(){
    if (Presto.merchant.giftMessageEnabled) {
      Presto.user.order.gift_instructions = $('#gift_instructions').val();
    }
    if (Presto.user.loginStatus) {
      /* User is logged in. Show the checkout_logged_in.hbs screen */
      console.debug("Showing checkout page for logged in user");
      templateData = {
        user: Presto.user,
        order: Presto.user.order,
        outlet: Presto.merchant.outletsHash[Presto.merchant.catalog.outlet_id]
      };
      Presto.showTemplate('www/templates/checkout_logged_in.hbs', templateData);
    } else {
      console.debug("Showing checkout page for logged out user");
      Presto.showTemplate('www/templates/checkout_logged_out.hbs', Presto.user.order);
    }
  },
  
  showAddressOptions: function() {
    console.debug("Showing address options");
    Presto.flagChosenAddress();
    Presto.showTemplate('www/templates/choose_address.hbs', Presto.user);
  },
  
  flagChosenAddress: function() {
    console.debug("flagChosenAddress called. No of addresses = " + JSON.stringify(Presto.user.addresses.length));
    for(var i in Presto.user.addresses) {
      console.debug("Current address : " + JSON.stringify(Presto.user.addresses[i]));
      if (Presto.user.addresses[i].id == Presto.user.chosenAddress.id) {
        Presto.user.addresses[i].chosenAddress = true;
      } else {
        Presto.user.addresses[i].chosenAddress = false;
      }
    }
  },
  
  updateChosenAddress: function(addressId) {
    if (addressId == Presto.user.chosenAddress.id) {
      console.debug("Same address chosen. Not changing chosenAddress");
    } else {
      console.debug("New address chosen.");
      if (Presto.user.addressesHash[addressId]) {
        console.debug("New full address = " + Presto.user.addressesHash[addressId].full_address);
        Presto.user.chosenAddress = Presto.user.addressesHash[addressId];
      } else {
        console.error("New address chosen was not found.. !!??! Not changing anything");
      }
    }
    
    Presto.checkoutOrder();
  },
  
  addAddress: function() {
    console.debug("Adding an address");
    if(Presto.addNewAddress()){
    Presto.checkoutOrder();
  }
  },
  
  addAccountAddress: function(){
    Presto.addNewAddress();
    Presto.showTemplate('www/templates/manage_account.hbs', Presto.user);
  },
  
  addNewAddress: function() {
    console.debug("Adding a new address");
    var new_address = {
      line1: $('#user_address_line1').val(),
      line2: $('#user_address_line2').val(),
      city: $('#user_address_city').val(),
      state: $('#user_address_state').val(),
      pincode: $('#user_address_pincode').val(),
      landmark: $('#user_address_landmark').val()
    };
       
    if($('#user_address_line1').val() == ""){
    Presto.showAlert("Please enter delivery address");
    return;
    }

    if($('#user_address_city').val() == ""){
    Presto.showAlert("Please enter your city name");
    return;
    }

    if($('#user_address_state').val() == ""){
    Presto.showAlert("Please enter your state name");
    return;
    }

    if($("#user_address_pincode").val() == "" && ($("#user_address_pincode").attr("required") == "true" || $("#user_address_pincode").attr("required") == "required")){
    Presto.showAlert("Please enter your area pin code");
    return false;
  }
    new_address.full_address = Presto.utils.concatHashKeys(new_address, ['line1', 'line2', 'city', 'pincode']);
    console.debug("full_address = " + new_address.full_address);
    Presto.user.addresses.push(new_address);
    Presto.user.chosenAddress = new_address;
  return true;
  },
  
  deleteUserAddress: function(addressId) {
    console.debug("Deleting address with id : " + addressId);
    addressPosition = Presto.user.addresses.map(function(addr) { return addr.id; } ).indexOf(addressId);
    if (addressPosition > -1) {
      var addressDeleteUrl = "http://" + Presto.app.host + "/addresses/" + addressId;
      $.ajax(addressDeleteUrl, {
        type: 'DELETE',
        contentType: 'application/json; charset=utf-8',
        success: function(responseData, status, xhr) {
          console.debug("Delete address successful");
        },
        error: function(responseData, status, xhr) {
          console.debug("Delete address failed with status : " + status);
          console.debug("Response = " + responseData.toString());
        }
      });
      Presto.deleteUserAddressLocally(addressId, addressPosition);
    } else {
      console.debug("Specified address not found in the list of addresses. Not doing anything");
    }
  },
  
  deleteUserAddressLocally: function(addressId, position) {
    console.debug("Deleting address with id : " + addressId + " locally");
    address = Presto.user.addresses.splice(position, 1);
    delete Presto.user.addressesHash[addressId];
    if (addressId == Presto.user.chosenAddress.id) {
      Presto.user.chosenAddress = Presto.user.addresses[0];
    }
    $('#address-' + addressId).remove();
  },

  editUserDetails: function(userId) {
    userAccountDetails = {
      authenticity_token: Presto.app.authToken,
      user: {
        name: $("#new_user_name").val(),
        email: $("#new_user_email").val(),
        phone_number: $("#new_user_phone_number").val()
      },
      merchant_id: Presto.merchant.id,
      app_id: Presto.merchant.app_id
    };

    var letters = /^[A-Za-z\ ]+$/;
    if(!$("#new_user_name").val().trim().match(letters)){
      Presto.showAlert("Please enter valid name with alphabet characters only");
      return;
    }

    if($("#new_user_email").val() == "" && ($("#new_user_email").attr("required") == "true" || $("#new_user_email").attr("required") == "required")){
      Presto.showAlert("Please enter your email to place the order");
      return;
    }

    var regex = /^[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,}$/;
    if(!$("#new_user_email").val().trim().match(regex)){
      Presto.showAlert("Please enter valid email");
      return;
    }

    if($("#new_user_phone_number").val() == "" && ($("#new_user_phone_number").attr("required") == "true" || $("#new_user_phone_number").attr("required") == "required")){
      Presto.showAlert("Please enter your phone number to place the order");
      return;
    }

    var phone_number = $("#new_user_phone_number").val();
    var phone_number_match_regex = /^(?:(?:\+|)91|[0]?)?\d{10}$/

    if(!phone_number.match(phone_number_match_regex)){
      Presto.showAlert("Please enter a valid phone number!");
      return;
    }

    console.debug("Editing user info: " + userId);
    var userDetailsUrl = "http://" + Presto.app.host + "/users/" + Presto.user.id + ".json";
    $.blockUI(Presto.getThrobberData("Updating your deatils"));
    $.ajax(userDetailsUrl, {
      type: 'PUT',
      data: JSON.stringify(userAccountDetails),
      contentType: 'application/json; charset=utf-8',
      //dataType: 'json',
      success: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("User details updated");
        Presto.user.phoneNumber = responseData.phone_number;
        Presto.user.name = responseData.name;
        Presto.user.email = responseData.email;
        Presto.fetchAndUpdateUserData();
        Presto.populateSidebarView();
        Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
      },
      error: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("Update user detail Request failed with status : " + status);
        var responseData = responseData.responseJSON;
        var errorMessage = "";
        if(typeof(responseData.email) != "undefined"){
          errorMessage = responseData.email;
        }
        else if(typeof(responseData.phone_number) != "undefined"){
          errorMessage = responseData.phone_number;
        }
        Presto.showAlert("Update user detail Request failed - " + errorMessage);
      }
    });
  },
  
  placeOrderWithSignup: function(paymentType) {
    if(!paymentType){
      paymentType = "COD";
    }
    console.debug("Placing order with use sign up");
  if($("#free_text_order").length > 0 && $("#free_text_order").val().trim() == ""){
    Presto.showAlert("Please add items before placing the order");
    return;
  }
  
  var letters = /^[A-Za-z\ ]+$/;
  if(!$("#user_name").val().trim().match(letters)){
    Presto.showAlert("Please enter valid name with alphabet characters only");
    return;
  }
  
  if($("#user_email").val() == "" && ($("#user_email").attr("required") == "true" || $("#user_email").attr("required") == "required")){
    Presto.showAlert("Please enter your email to place the order");
    return;
  }
  
  if($("#user_phone_number").val() == "" && ($("#user_phone_number").attr("required") == "true" || $("#user_phone_number").attr("required") == "required")){
    Presto.showAlert("Please enter your phone number to place the order");
    return;
  }
  
  //Adding phone number validation 
  
  var phone_number = $("#user_phone_number").val();
  var phone_number_match_regex = /^(?:(?:\+|)91|[0]?)?\d{10}$/
  
  if(!phone_number.match(phone_number_match_regex)){
    Presto.showAlert("Please enter a valid phone number!");
    return;
  }
  
  //Add some input validation. 
  if($("#user_phone_number").val() == "" && $("#user_email").val() == ""){
    Presto.showAlert("Please enter either phone number of email to place the order");
    return;
  }
  
  if($("#user_password").length > 0 && $("#user_password").val().length < 8){
    Presto.showAlert("Password should be atleast 8 characters");
    return;
  }
  
  if($("#user_address_line1").val() == ""){
    Presto.showAlert("Please enter address");
    return;
  }

  if($('#user_address_city').val() == ""){
    Presto.showAlert("Please enter your city name");
    return;
  }

  if($('#user_address_state').val() == ""){
    Presto.showAlert("Please enter your state name");
    return;
  }
  
  if($("#user_address_pincode").val() == "" && ($("#user_address_pincode").attr("required") == "true" || $("#user_address_pincode").attr("required") == "required")){
    Presto.showAlert("Please enter your area pin code");
    return;
  }

  if (Presto.user.deliveryDateAndTimeSelected) {
    if(Presto.chosenAppointmentDate == undefined || Presto.chosenAppointmentTime == undefined){
      Presto.showAlert("Please select a date and time");
      return;
    }
    if (!Presto.merchant.allowPreviousDate) {
      var today = new Date();
      Presto.chosenAppointmentDate.setHours(23,59,59,0);
      if (Presto.chosenAppointmentDate < today) {
        Presto.showAlert("Please select a future date");
        return;
      }
    }
  }
  
  if($("#storeList").val() == "" && $("#storeList").length > 0 && $("#storeList").attr("required") == "required"){
    Presto.showAlert("Please choose an outlet");
    return;
  }
  
  
    Presto.user.order.outletId = Presto.merchant.catalog.outlet_id;
    userData = Presto.buildUserRegistrationData();
    orderData = Presto.buildOrderData();
    orderData.address = userData.address;
    orderData.user = userData;
    
    postData = {
      authenticity_token: Presto.app.authToken,
      order: orderData,
      payment_type: paymentType
    };
    postData.order.address = userData.address;
    postData.order.user = userData;
    Presto.submitOrder(postData);
  },
   
  checkAndApplyDiscountCoupon: function(event){
    var couponCode = $("#couponCode").val();
    if((couponCode).length == 0){
    Presto.showAlert("Please enter coupon code");
    return;
    }
    Presto.couponCode = couponCode;

     if(!Presto.user.loginStatus){
      userData = Presto.buildUserRegistrationData();
    }else{
      userData = Presto.buildLoggedInUserData();
    }
    
    orderData = Presto.buildOrderData();
    var couponData = {
      user: userData,
      order: orderData,
      merchant_id: Presto.merchant.id,
      app_id: Presto.merchant.app_id
    }
    
    couponData.order.user = userData;
    couponData.order.address = userData.address;
    
    var couponCheckUrl = "http://" + Presto.app.host + "/api/1/orders/apply_coupon.json";
    console.debug("Sending POST request to " + couponCheckUrl + " with data = \n" + JSON.stringify(couponData));
    $.blockUI(Presto.getThrobberData("Applying the coupon"));
    $.ajax(couponCheckUrl, {
      type: 'POST',
      data: JSON.stringify(couponData),
      contentType: 'application/json; charset=utf-8',
      success: function(responseData, status, xhr){
        $.unblockUI();
        if(responseData.discount_available && responseData.discount_value && responseData.discount_value > 0){
          var discount_value = responseData.discount_value;
          var discounted_bill_amount = responseData.discount_bill;
          if(Presto.merchant.deliveryCharges){
            discounted_bill_amount = discounted_bill_amount/100;
            discounted_bill_amount+= parseInt(Presto.merchant.deliveryCharges);
            $("#couponDiscountedBillAmount").html("₹&nbsp;" + discounted_bill_amount);
            $("#discountedValue").html("₹&nbsp;" + discounted_bill_amount);
          }else{
            $("#couponDiscountedBillAmount").html("₹&nbsp;" + discounted_bill_amount/100);
          }
          $("#couponBillAmount").html("₹&nbsp;" + Presto.user.order.billAmount);
          $("#couponSavings").html("₹&nbsp;" + discount_value/100);
          $(".ordersnapshot").removeClass("hidden");
          $(".couponBill").removeClass("hidden");
          $(".billAmount").addClass("hidden");
        }else {
          Presto.showAlert("Sorry! Invalid coupon code!");
          $(".ordersnapshot").addClass("hidden");
          $(".couponBill").addClass("hidden");
          $(".billAmount").removeClass("hidden");
        }
      },
      error: function(xhr, status, reason){
        $.unblockUI();
        var responseData = JSON.parse(xhr.responseText);
        var errorMessage = "";
        if(typeof(responseData.msg) != "undefined"){
          errorMessage = responseData.msg;
        }
        else if(typeof(responseData.message) != "undefined"){
          errorMessage = responseData.message;
        }
        else if(typeof(responseData.error_message) != "undefined"){
          errorMessage = responseData.error_message;
        }
        //PrestoAnalytics.trackException("Could not apply the coupon - " + errorMessage, true);
        Presto.showAlert("Could not apply the coupon - " + errorMessage);
      }
    }); 
  },
  
  submitOrder: function(postData) {
    postData.merchant_id = Presto.merchant.id;
    postData.app_id = Presto.merchant.app_id;
    var orderUrl = "http://" + Presto.app.host + "/orders.json"
    console.debug("Sending POST request to " + orderUrl + " with data = \n" + JSON.stringify(postData));
    $.blockUI(Presto.getThrobberData("Placing the order"));
    $.ajax(orderUrl, {
      type: 'POST',
      data: JSON.stringify(postData),
      contentType: 'application/json; charset=utf-8',
      //dataType: 'json',
      success: function(responseData, status, xhr) {
        if(Presto.app.payment_enabled && postData.payment_type == "ONLINE"){
          if(Presto.app.razor_pay) {
            $.blockUI(Presto.getThrobberData("Initiating online transaction"));
            var paymentUrl = "http://" + Presto.app.host + "/payments/razor/new_payment.json?order_id=" + responseData.id
            $.ajax(paymentUrl, {
              type: 'GET',
              contentType: 'application/json; charset=utf-8',
              success: function(paymentResponseData, status, xhr) {
                $.unblockUI();
                var options = {
                    description: 'Order Payment',
                    image: Presto.app.merchantLogoFilePath,
                    currency: Presto.app.currency,
                    key: Presto.app.razorApiKey,
                    amount: responseData.total_amount * 100,
                    name: Presto.merchant.name,
                    prefill: {email: Presto.user.email, contact: Presto.user.phoneNumber, name: Presto.user.name},
                    theme: {color: Presto.app.razorPayThemeColor}
                }

                var successCallback = function(payment_id) {
                  $.blockUI(Presto.getThrobberData("Completing online transaction"));
                  var razorCallBackUrl = paymentResponseData.payment_response.razor_post_url
                    $.ajax(razorCallBackUrl, {
                      type: 'POST',
                      data: JSON.stringify({"razorpay_payment_id": payment_id}),
                      contentType: 'application/json; charset=utf-8',
                      //dataType: 'json',
                      success: function(postOrderCaptureData, status, xhr) {
                        $.unblockUI();
                        Presto.resetOrder();
                        Presto.fetchAndUpdateUserData();
                        Presto.showOrderConfirmation(responseData, Presto.user.order);
                      },
                      error: function(xhr, status, reason){
                        $.unblockUI();
                        Presto.showAlert("Payment was not successful - " + xhr.responseText);
                      }
                    });
                }

                var cancalCallback = function(error) {
                    $.unblockUI();
                    alert(error.description + ' (Error '+error.code+')');
                }

                RazorpayCheckout.open(options, successCallback, cancalCallback);
              },
              error: function(xhr, status, reason) {
                $.unblockUI();
                alert("Could not initiate online transaction");
              }
            });
            
          }else {
            try{
              Presto.intermediateExit = true;
              ref = window.open("http://" + Presto.app.host + responseData.pg_url, "_blank", "location=no");
              ref.addEventListener('loadstop', function(event) { 
                if(event.url.indexOf("gateway_response")>=0){
                  Presto.intermediateExit = false;
                  ref.close();
                  var payment_url = event.url.substring(0, event.url.indexOf("gateway_response") - 1);
                  $.ajax(payment_url+".json", {
                    type: 'GET',
                    contentType: 'application/json; charset=utf-8',
                    success: function(paymentResponse, status, xhr) {
                      if(paymentResponse.status == "SUCCESS"){
                        console.debug("Placed order successfully");
                        $.unblockUI();
                        if(postData.order.type && postData.order.type == "free_text"){
                          Presto.showQuickOrderConfirmation(responseData, postData.order);
                        }else {
                          Presto.showOrderConfirmation(responseData, postData.order);
                        }
                        PrestoAnalytics.trackEvent('order', "Order Placed");
                        var order = Presto.user.order;
                        order.id = responseData.id;
                        PrestoAnalytics.trackOrderPlaced(order);
                        Presto.resetOrder();
                        Presto.fetchAndUpdateUserData();
                      }else {
                        $.unblockUI();
                        Presto.showAlert("Payment was not successful - " + paymentResponse.reason);
                      }
                    },
                    error: function(xhr, status, reason){
                      $.unblockUI();
                      Presto.showAlert("Payment was not successful" + xhr.responseText);
                    }
                  });
                
                
                }; 
              });
      
              ref.addEventListener('exit', function(event) { 
                if(Presto.intermediateExit){
                  $.unblockUI();
                  Presto.showAlert("Payment has been cancelled");
                }
              
              });
      
            }catch(e){
              //Some unknown error. Need to push to analytics later on. 
            }
          }
          
        }else {
          $.unblockUI();
          console.debug("Placed order successfully");
          if(postData.order.type && postData.order.type == "free_text"){
            Presto.showQuickOrderConfirmation(responseData, postData.order);
          }else {
            Presto.showOrderConfirmation(responseData, Presto.user.order);
          }
          PrestoAnalytics.trackEvent('order', "Order Placed");
          var order = Presto.user.order;
          order.id = responseData.id;
          PrestoAnalytics.trackOrderPlaced(order);
          Presto.resetOrder();
          Presto.fetchAndUpdateUserData();
        }
        
      },
      error: function(xhr, status, reason) {
        $.unblockUI();
        console.debug("Placing order failed with status : " + status);
        console.debug(xhr.responseText);
        var responseData = JSON.parse(xhr.responseText);
        var errorMessage = "";
        if(typeof(responseData.msg) != "undefined"){
          errorMessage = responseData.msg;
        }
        else if(typeof(responseData.message) != "undefined"){
          errorMessage = responseData.message;
        }
        else if(typeof(responseData.error_message) != "undefined"){
          errorMessage = responseData.error_message;
        }
        PrestoAnalytics.trackException("Could not place the order - " + errorMessage, true);
        Presto.showAlert("Could not place the order - " + errorMessage);
        /*Presto.showOrderConfirmation(responseData, Presto.user.order);
        Presto.resetOrder();
        Presto.fetchAndUpdateUserData();*/
        if(!Presto.user.loginStatus){
          $.blockUI(Presto.getThrobberData("Restoring your cart. You can try placing the order again"));
          Presto.fetchAndUpdateUserData(function() {
            $.unblockUI();
            Presto.showOrderSummary();
            Presto.showAlert("Could not place the order - " + errorMessage);
          }, function() {
            $.unblockUI();
            Presto.showAlert("Could not place the order - " + errorMessage);
          });
        }
    
      }
    });
  },
  
  buildUserRegistrationData: function() {
    console.debug("Building user registration data");
    userData = {
      name: $("#user_name").val(),
      phone_number: $('#user_phone_number').val(),
      email: $('#user_email').val(),
      password: $('#user_password').val(),
      merchant_id: Presto.merchant.id,
      address: {
        line1: $('#user_address_line1').val(),
        line2: $('#user_address_line2').val(),
        city: $('#user_address_city').val(),
        state: $('#user_address_state').val(),
        pincode: $('#user_address_pincode').val(),
        landmark: $('#user_address_landmark').val()
      }
    };
    return userData;
  },
  
  buildOrderData: function() {
    console.debug("Building order data");
    Presto.user.order.instructions = $('#order_instructions').val();
  var orderData = {};
  
    if($("#free_text_order").length > 0){
    orderData = {
      "type": "free_text",
      "order_text": $("#free_text_order").val()
    }
  }else {
    orderData = {
        outlet_id: Presto.merchant.catalog.outlet_id,
        merchant_id: Presto.merchant.id,
        delivery_time: new Date(new Date().getTime() + 1800000).toISOString(),
        instructions: Presto.user.order.instructions,
        service_type: 'delivery',
        line_items: []
      };
      if (Presto.merchant.giftMessageEnabled) {
        orderData.gift_instructions = Presto.user.order.gift_instructions;
      }
      if(Presto.user.chosenOutlet){
        orderData.outlet_id = Presto.user.chosenOutlet;
      }else if(Presto.merchant.nearestOutlet){
        orderData.outlet_id = Presto.merchant.nearestOutlet.id;
      }
      if(Presto.user.order.chosenTimeSlot){
        orderData.time_slot = Presto.user.order.chosenTimeSlotValue;
        orderData.time_slot_value = Presto.user.order.userChoosenDate + " " + Presto.user.order.chosenTimeSlot;
      }
      if(Presto.merchant.pickupOnly){
        orderData.service_type = 'pickup'
      }
      for (var i in Presto.user.order.lineItems) {
        var item = Presto.user.order.lineItems[i];
        var lineItem = {
          item_id: item.itemId,
          quantity: item.quantity,
          total_price: item.totalPrice,
          variation_id: item.variationId
        };
        orderData.line_items.push(lineItem);
      }
      
      if(Presto.app.discount_coupon_enabled){
        orderData.coupon_code = Presto.couponCode;
      }
  }
    
    return orderData;
  },
  
  showOrderConfirmation: function(responseData, order) {
    templateData = {
    merchant: Presto.merchant,
      order: order,
      outlet: Presto.merchant.outletsHash[order.outletId],
      user: Presto.user
    };
    if (responseData.loyalty_points) {
      templateData.loyaltyPoints = responseData.loyalty_points;
    }
    Presto.showTemplate('www/templates/order_confirmation.hbs', templateData);
  },
  
  showQuickOrderConfirmation: function(responseData, order) {
    templateData = {
    merchant: Presto.merchant,
      order: order,
      outlet: Presto.merchant.outletsHash[order.outletId]
    };
    if (responseData.loyalty_points) {
      templateData.loyaltyPoints = responseData.loyalty_points;
    }
    Presto.showTemplate('www/templates/quick_order_confirmation.hbs', templateData);
  },

  inviteFriends: function() {
    PrestoAnalytics.trackEvent("buttonClick", "inviteFriends");
    tempData = {
      merchant: Presto.merchant,
      user: Presto.user
    };
    Presto.showTemplate('www/templates/invite.hbs', tempData);
  },

  trackAndShowLastOrder: function() {
    PrestoAnalytics.trackEvent("buttonClick", "trackOrderButton");
    $.blockUI(Presto.getThrobberData("Track Order"));
    var my_ordersUrl = "http://" + Presto.app.host + "/my_orders.json";
    $.get(my_ordersUrl, function(data, status, xhr) {
      $.unblockUI();
      Presto.user.currentOrder = data.orders[Object.keys(data.orders)[0]];
      templateData = {
        order: Presto.user.currentOrder,
        merchant: Presto.merchant
      };
      Presto.showTemplate('www/templates/track_order_final.hbs', templateData);          
    }).fail(function(xhr, status, error) {
      $.unblockUI();
      var error_msg = JSON.parse(xhr.responseText).message.replace("\n", "<br/>");
      Presto.showAlert("Unable to track <br/>" + error_msg);
    });
  },

  showAllOrdersPage: function(){
    $.blockUI(Presto.getThrobberData("Track Order"));
    var my_ordersUrl = "http://" + Presto.app.host + "/my_orders.json";
      $.get(my_ordersUrl, function(data, status, xhr) {
        $.unblockUI();
        Presto.user.orders = data;
        if(data.length == 0){
          Presto.showAlert("Please place an order");
        } else {
          Presto.showTemplate('www/templates/order_list.hbs', data);
        }
      }).fail(function(xhr, status, error) {
        $.unblockUI();
        var error_msg = "";
        var message = JSON.parse(xhr.responseText).message;
        if(message && message != ""){
          error_msg = message;
        }
        Presto.showAlert("Unable to fetch your orders <br/>" + error_msg);
      });
  },
  
  showLoginPage: function(currentPage) {
    console.debug("Showing login page");
    Presto.showTemplate('www/templates/login.hbs', {lastPage: currentPage});
  },
  
  showResetPasswordPage: function(currentPage) {
    console.debug("Showing reset password page");
    Presto.showTemplate('www/templates/reset_password.hbs', {lastPage: currentPage});
  },
  
  resetPassword: function(currentPage){
    resetParams = {
      authenticity_token: Presto.app.authToken,
      user: {
        login: $('#user_login').val()
      },
      merchant_id: Presto.merchant.id,
      app_id: Presto.merchant.app_id
    };
    
    console.debug("Request reset with data : " + JSON.stringify(resetParams));
    var requestResetUrl = "http://" + Presto.app.host + "/users/reset_password.json";
    $.blockUI(Presto.getThrobberData("Resetting your password"));
    $.ajax(requestResetUrl, {
      type: 'POST',
      data: JSON.stringify(resetParams),
      contentType: 'application/json; charset=utf-8',
      //dataType: 'json',
      success: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("Request Reset successful");
        Presto.showSetPasswordPage(currentPage, resetParams.user.login);
      },
      error: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("Reset Request failed with status : " + status);
        console.debug("Response = " + JSON.stringify(responseData));
        var responseData = responseData.responseJSON;
        var errorMessage = "";
        if(typeof(responseData.msg) != "undefined"){
          errorMessage = responseData.msg;
        }
        else if(typeof(responseData.message) != "undefined"){
          errorMessage = responseData.message;
        }
        else if(typeof(responseData.error_message) != "undefined"){
          errorMessage = responseData.error_message;
        }
        Presto.showAlert("Reset Request Failed - " + errorMessage);
      }
    });
  },
  
  showSetPasswordPage: function(currentPage, login) {
    console.debug("Showing Set password page");
    Presto.showTemplate('www/templates/set_password.hbs', {lastPage: currentPage, login: login});
  },
  
  setPassword: function(currentPage){
    setParams = {
      authenticity_token: Presto.app.authToken,
      user: {
        token: $("#user_token").val(),
        login: $("#user_login").val(),
        password: $('#user_password').val()
      },
      merchant_id: Presto.merchant.id,
      app_id: Presto.merchant.app_id
    };

  var letters = /^\S+$/;
  if (!$("#user_token").val().match(letters)) {
    var setPasswordErrorMessage = Presto.merchant.setPasswordMessage;
    if (setPasswordErrorMessage == "") {
      Presto.showAlert("Please enter valid token");
    } else {
      Presto.showAlert(setPasswordErrorMessage);
    }
    return;
  }
    
    console.debug("Request set with data : " + JSON.stringify(resetParams));
    var setPasswordUrl = "http://" + Presto.app.host + "/users/set_password.json";
    $.blockUI(Presto.getThrobberData("Updating your password"));
    $.ajax(setPasswordUrl, {
      type: 'POST',
      data: JSON.stringify(setParams),
      contentType: 'application/json; charset=utf-8',
      //dataType: 'json',
      success: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("Set Password successful");
        Presto.loginUser(currentPage);
      },
      error: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("Update Password Request failed with status : " + status);
        console.debug("Response = " + responseData.toString());
        var responseData = responseData.responseJSON;
        var errorMessage = "";
        if(typeof(responseData.msg) != "undefined"){
          errorMessage = responseData.msg;
        }
        else if(typeof(responseData.message) != "undefined"){
          errorMessage = responseData.message;
        }
        else if(typeof(responseData.error_message) != "undefined"){
          errorMessage = responseData.error_message;
        }
        Presto.showAlert("Update Password Failed - " + errorMessage);
      }
    });
  },
  
  showSignupPage: function(currentPage) {
    console.debug("Showing signup page");
    Presto.showTemplate('www/templates/signup.hbs', {lastPage: currentPage});
  },
  
  showNotifications: function(currentPage) {
    console.debug("Showing notifications");
    var deviceId = Presto.app.deviceId;
    if(!deviceId || deviceId == ""){
      deviceId = window.localStorage.getItem("Presto.app.deviceId");
      if (!deviceId || deviceId == "") {
        //No device configured to receive notifications. Show empty notifications
        Presto.showTemplate('www/templates/notification.hbs', {notifications: [], lastPage: currentPage});
        return;
      }
    }
    var notificationsUrl = "http://" + Presto.app.host + "/devices/" + deviceId + "/notifications.json";
    $.blockUI(Presto.getThrobberData("Fetching your notifications"));
    $.get(notificationsUrl, function(notifications, status, xhr) {
      $.unblockUI();
      Presto.showTemplate('www/templates/notification.hbs', {notifications: notifications, lastPage: currentPage});
    }).fail(function(xhr, status, reason){
      $.unblockUI();
      Presto.showAlert("Could not fetch notifications - " + xhr.responseText);      
    });
    
  },
    
  loginUser: function(lastPage) {
    loginParams = {
      authenticity_token: Presto.app.authToken,
      user: {
        login: $('#user_login').val(),
        password: $('#user_password').val()
      },
      merchant_id: Presto.merchant.id,
      app_id: Presto.merchant.app_id
    };
    
    var nextPage = 'www/templates/home.hbs';
    var nextPageData = {};
    
    console.debug("Logging user in with data : " + JSON.stringify(loginParams));
    var loginUrl = "http://" + Presto.app.host + "/users/sign_in.json";
    $.blockUI(Presto.getThrobberData("Logging you in"));
    $.ajax(loginUrl, {
      type: 'POST',
      data: JSON.stringify(loginParams),
      contentType: 'application/json; charset=utf-8',
      //dataType: 'json',
      success: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("Login successful");
        Presto.user.loginStatus = true;
        $.blockUI(Presto.getThrobberData("Fetching your delivery details"));
        
        Presto.fetchAndUpdateUserData(function() {
          $.unblockUI();
          if (lastPage == 'checkout_logged_out' || lastPage == 'www/templates/checkout_logged_out.hbs') {
            nextPage = 'www/templates/checkout_logged_in.hbs'
            nextPageData = {
              user: Presto.user,
              order: Presto.user.order
            };
          }else if(lastPage == "outlet_detail" || lastPage == "www/templates/outlet_detail.hbs") {
            nextPage = 'www/templates/outlet_detail.hbs';
            var outlet = Presto.merchant.outletsHash[Presto.merchant.catalog.outlet_id];
            var nextPageData = {
              outlet: outlet,
              services: outlet.services,
              timeslots: ["11.00 AM", "12.00 PM", "1.00 PM", "2.00 PM", "3.00 PM", "4.00 PM", "5.00 PM", "6.00 PM"],
              merchant: Presto.merchant
            }
    
            Presto.merchant.catalog.outlet_id = outlet.id;
            if(Presto.user.loginStatus){
              nextPageData.user = Presto.user;
            }
          }
          Presto.showTemplate(nextPage, nextPageData);
        }, function() {
      $.unblockUI();
          Presto.showAlert("Sorry, could not fetch your delivery details. Please sign in with the right credentials or sign up");
          $('#user_password').val('');
        });
        Presto.populateSidebarView();
      },
      error: function(responseData, status, xhr) {
        $.unblockUI();
        console.debug("Login failed with status : " + status);
        console.debug("Response = " + responseData.toString());
        Presto.showAlert("Login failed. Please try again");
        $('#user_password').val('');
      }
    });
  },
  
  fetchAndUpdateUserData: function(successCallback, errorCallback) {
    var userDataUrl = "http://" + Presto.app.host + "/me.json";
    $.get(userDataUrl, function(userData, status, xhr) {
      //register device is sending the deviceId appropriately. So commenting the reading of deviceId from cookie. We can revisit this later.
      //Presto.app.deviceId = Presto.getDeviceIdFromCookie(xhr.getResponseHeader('Set-Cookie'));
      Presto.user.loginStatus = true;
      Presto.user.id = userData.id;
      Presto.user.phoneNumber = userData.phone_number;
      Presto.user.name = userData.name;
      Presto.user.email = userData.email;
      Presto.user.addresses = userData.addresses
      Presto.user.chosenAddress = Presto.user.addresses[0];
      Presto.user.addressesHash = Presto.utils.hashifyArray(Presto.user.addresses, 'id');
      Presto.user.ref_code = userData.ref_code;
    
      Presto.populateSidebarView();
      if (successCallback && typeof(successCallback) == 'function') {
        successCallback();
      }
      if(Presto.merchant.prepaid_card_enabled){
        $.get("http://" + Presto.app.host + Presto.merchant.prepaid_card_api, function(ppcData, status, xhr) {
          var expiryDate = new Date(ppcData.expiry);
          ppcData.days_to_expiry = Math.round((expiryDate - new Date())/(1000*60*60*24));
          $(".prepaidMeter").html(Presto.templates["www/templates/prepaid_meter.hbs"](ppcData));
          $(".prepaidDetails").html(Presto.templates["www/templates/prepaid_details.hbs"](ppcData));
          Presto.user.ppcData = ppcData;
        }).fail(function(xhr, status, reason){
          //No Prepaid card data
        });
      }
    }).fail(function(xhr, status, error) {
      //register device is sending the deviceId appropriately. So commenting the reading of deviceId from cookie. We can revisit this later.
      //Presto.app.deviceId = Presto.getDeviceIdFromCookie(xhr.getResponseHeader('Set-Cookie'));
      Presto.user.loginStatus = false;
      Presto.populateSidebarView();
      if (errorCallback && typeof(errorCallback) == 'function') {
        errorCallback();
      }
    });
  },
  
  getDeviceIdFromCookie: function(cookieHeader){
    var obj = {}
    var pairs = cookieHeader.split(/; */);
    pairs.forEach(function(pair) {
    var eq_idx = pair.indexOf('=')

    // skip things that don't look like key=value
    if (eq_idx < 0) {
        return;
    }

    var key = pair.substr(0, eq_idx).trim()
    var val = pair.substr(++eq_idx, pair.length).trim();

    // quoted values
    if ('"' == val[0]) {
        val = val.slice(1, -1);
    }

    // only assign once
    if (undefined == obj[key]) {
        try {
            obj[key] = dec(val);
        } catch (e) {
            obj[key] = val;
        }
    }
    });
    return obj["deviceId"];
  },
  
  buildLoggedInUserData: function() {
    console.debug("Building logged in user data");
    userData = {
      name: Presto.user.name,
      phone_number: Presto.user.phoneNumber,
      merchant_id: Presto.merchant.id,
      address: Presto.user.chosenAddress
    };
  
  if(!userData.address){
        userData.address =  {
          line1: $('#user_address_line1').val(),
          line2: $('#user_address_line2').val(),
          city: $('#user_address_city').val(),
          state: $('#user_address_state').val(),
          pincode: $('#user_address_pincode').val(),
          landmark: $('#user_address_landmark').val()
        }
  }
    return userData;
  },
  
  placeOrderLoggedIn: function(paymentType) {
    if(!paymentType){
      paymentType = "COD";
    }
    console.debug("Placing order for logged in user");
  if($("#free_text_order").length > 0 && $("#free_text_order").val().trim() == ""){
    Presto.showAlert("Please add items before placing the order");
    return;
  }
    if($("#storeList").val() == "" && $("#storeList").length > 0 && $("#storeList").attr("required") == "required"){
      Presto.showAlert("Please choose an outlet");
      return;
    }
  
  if($("#user_address_line1").length > 0 && $("#user_address_line1").val() == ""){
    Presto.showAlert("Please enter address");
    return;
  }

    if($('#user_address_city').val() == ""){
    Presto.showAlert("Please enter your city name");
    return;
    }

    if($('#user_address_state').val() == ""){
    Presto.showAlert("Please enter your state name");
    return;
    }

  if(Presto.user.deliveryDateAndTimeSelected) {
    if(Presto.chosenAppointmentDate == undefined || Presto.chosenAppointmentTime == undefined){
      Presto.showAlert("Please select a date and time");
      return;
    }
    if (!Presto.merchant.allowPreviousDate) {
      var today = new Date();
      Presto.chosenAppointmentDate.setHours(23,59,59,0);
      if (Presto.chosenAppointmentDate < today) {
        Presto.showAlert("Please select a future date");
        return;
      }
    }
  }
  
    if($("#user_address_pincode").val() == "" && ($("#user_address_pincode").attr("required") == "true" || $("#user_address_pincode").attr("required") == "required")){
    Presto.showAlert("Please enter your area pin code");
    return;
  }
    orderData = Presto.buildOrderData();
    userData = Presto.buildLoggedInUserData();
    postData = {
      authenticity_token: Presto.app.authToken,
      order: orderData,
      payment_type: paymentType
    };
    postData.order.address = userData.address;
    postData.order.user = userData;
    Presto.submitOrder(postData);
  },
  
  clearOrderAndShowHome: function() {
    console.debug("Clear order and showing home");
    Presto.resetOrder();
    Presto.showTemplate('www/templates/home.hbs', Presto.merchant);
  },

  clearOrderAndShowCategory: function() {
    console.debug("Clear order and showing home");
    Presto.resetOrder();
    var categoryId = Presto.merchant.catalog.categories[0].id;
    var templateData = Presto.merchant.catalog.categoryItems[categoryId];
    Presto.showTemplate('www/templates/category.hbs', templateData);
  },
  
  resetOrder: function() {
    Presto.user.order = {
      outletId: null,
      noOfItems: 0,
      totalPrice: 0,
      basePrice: 0,
      tax: 0,
    serviceTax: 0,
    vatAmount: 0,
      billAmount: 0,
      packagingAmount: 0,
    deliveryCharges: 0,
      lineItems: {}
    }
     $('#noOfItemsCount').html(Presto.user.order.noOfItems);
    Presto.setCatalogItemAddedCount();
    Presto.user.ChosenTimeSlot = null;
    Presto.user.chosenTimeSlotValue = null;
  },
  
  setCatalogItemAddedCount: function(){
    var categories = Presto.merchant.catalog.categories;
    for(var catIndex in categories) {
      var items = Presto.merchant.catalog.categoryItems[categories[catIndex].id].items;
      for (var i in items) {
        if (Presto.user.order.lineItems[items[i].id]) {
          items[i].addedCount = Presto.user.order.lineItems[items[i].id].quantity;
          items[i].addedClass = "added";
        } else {
          items[i].addedCount = 0;
          items[i].addedClass = "";
        }
        if(items[i].variations && items[i].variations != "") {
          $(items[i].variations).each(function(i, variation){
            if(Presto.user.order.lineItems[variation.id]) {
              variation.addedCount = Presto.user.order.lineItems[variation.id].quantity;
              variation.addedClass = "added";
            } else {
              variation.addedCount = 0;
              variation.addedClass = "";
            }
          });
        }
      }
    }
    var items = Presto.merchant.catalog.items;
    $(items).each(function(i, item){
      if (Presto.user.order.lineItems[item.id]) {
        item.addedCount = Presto.user.order.lineItems[item.id].quantity;
        item.addedClass = "added";
      } else {
        item.addedCount = 0;
        item.addedClass = "";
      }
    });
  },
  
  resetUserData: function() {
    Presto.user = {
      currentLocation: null,
      lastLocationFetchTime: null,
      loginStatus: false
    };
    Presto.resetOrder();
  },
  
  registerDevice: function(deviceToken) {
    
      postData = {
        device: {
          device_token: deviceToken,
          model: device.model,
          cordova: device.cordova,
          platform: device.platform,
          uuid: device.uuid,
          version: device.version
        }
      };
      var deviceUpdateUrl = "http://" + Presto.app.host + "/apps/" + Presto.app.db_id + "/devices.json";
      console.debug("Registering device with the following data: \n" + JSON.stringify(postData));
      $.ajax(deviceUpdateUrl, {
        type: 'POST',
        data: JSON.stringify(postData),
        contentType: 'application/json; charset=utf-8',
        //dataType: 'json',
        success: function(responseData, status, xhr) {
          console.debug("Device registered successfully");
          Presto.app.deviceId = responseData.id;
          console.log("Presto.app.deviceId=" + Presto.app.deviceId);
          if (Presto.app.deviceId && "" != Presto.app.deviceId && null != Presto.app.deviceId) {
            console.log("Saving device id " + Presto.app.deviceId + " in local storage");
            window.localStorage.setItem("Presto.app.deviceId",  Presto.app.deviceId);
          }
          PrestoAnalytics.setUserId(responseData.id);
        },
        error: function(responseData, status, xhr) {
          console.debug("Device registration failed with status : " + status);
          console.debug("Response = " + responseData.toString());
          PrestoAnalytics.trackException("Device registration failed : " + responseData.toString(), true);
        }
      });
      console.debug("Registered with ID: " + event.pushID);
    
  },
    
  showNotification: function(event) {
    console.debug("Incoming push: " + event.message);
    Presto.showNotifications("www/templates/home.hbs");
  },
  
  populateSidebarView: function() {
    var data = {}
    if(Presto.merchant && Presto.merchant.catalog){
      data.catalog = Presto.merchant.catalog;
      data.outlet = Presto.merchant.outletsHash[Presto.merchant.catalog.outlet_id];
      data.merchant = Presto.merchant;
    }
    if (Presto.user.loginStatus) {
      data.user = Presto.user;
      Presto.showTemplateInSidebar('www/templates/sidebar_logged_in.hbs', data);
      if(Presto.merchant.prepaid_card_enabled && Presto.user.ppcData){
        $(".prepaidMeter").html(Presto.templates["www/templates/prepaid_meter.hbs"](Presto.user.ppcData));
        $(".prepaidDetails").html(Presto.templates["www/templates/prepaid_details.hbs"](Presto.user.ppcData));
      }
    } else {
      Presto.showTemplateInSidebar('www/templates/sidebar_logged_out.hbs', data);
    }
  },
  
  showFavouriteItems: function() {
    console.debug("Showing favourite items");
    var userFavouritesUrl = "http://" + Presto.app.host + "/favorite_items.json";
    $.blockUI(Presto.getThrobberData("Fetching your favourites"));
    if (Presto.merchant.nearestOutlet){
      userFavouritesUrl = userFavouritesUrl + "?outlet_id=" + Presto.merchant.nearestOutlet.id;
      Presto.fetchFavoriteItems(userFavouritesUrl);    
    } else {
      Presto.fetchNearestOutlet(function(nearestOutlet) {
        var catalogUrl = "http://" + Presto.app.host + "/catalog.json?outlet_id=" + nearestOutlet.id;
        $.get(catalogUrl, function(catalogData, status, xhr) {
          Presto.merchant.catalog = catalogData;
          if(Presto.merchant.hasCategoryBar) {
            Presto.populateCategoryBar();
          }
          Presto.merchant.catalogFetched = true;
          Presto.merchant.outletsCatalog[Presto.merchant.nearestOutlet.id] = catalogData;
          userFavouritesUrl = userFavouritesUrl + "?outlet_id=" + Presto.merchant.nearestOutlet.id;
          Presto.fetchFavoriteItems(userFavouritesUrl);
          Presto.setCatalogItemAddedCount();
        });
      }, function(errorMessage) {
        console.debug("Could not fetch catalog for nearest store. Error : " + errorMessage);
        $.unblockUI();
        Presto.showAlert("Could not fetch your favourite items.");
      });
    }
  },
  
  fetchFavoriteItems: function(userFavouritesUrl){
    $.get(userFavouritesUrl, function(favouritesData, status, xhr) {
      var favouriteItems = [];
      for (var i in favouritesData.categoryItems) {
        favouriteItems = favouriteItems.concat(favouritesData.categoryItems[i].items);
      }
      $.unblockUI();
      Presto.showTemplate('www/templates/favourite_items.hbs', favouriteItems);
    }).fail(function(xhr, status, error) {
      $.unblockUI();
      console.error("Error fetching favourite items. \nStatus = " + status + "\nerror = " + JSON.stringify(error));
      Presto.showAlert("Could not fetch your favourite items. Please check your internet connection");
    });
  },
  
  showOffers: function() {
    console.debug("Showing Offers");
    var userOfferUrl = "http://" + Presto.app.host + "/offers.json";
    $.blockUI(Presto.getThrobberData("Fetching your offers"));
    $.get(userOfferUrl, function(offers, status, xhr) {
      $.unblockUI();
      Presto.showTemplate('www/templates/offers.hbs', {offers: offers});
    }).fail(function(xhr, status, error) {
      $.unblockUI();
    //To Be removed once offers api is in place.
      var offers = [
      {
      "title": "20% OFF ON YOUR NEXT VISIT AT THE NEAREST YLG OUTLET.",
      "description": "This offer is valid till 17th July 2014. This will be automatically available in your bill"
    },
      {
      "title": "24% OFF ON FACIALS",
      "description": "This offer is valid till 5th July 2014. This will be automatically available in your bill.."
    },
      {
      "title": "13% OFF ON PEDICURES",
      "description": "This offer is valid till 12th Auguest 2014. This will be automatically available in your bill.."
    }
    ]
    Presto.showTemplate('www/templates/offers.hbs', {offers: offers});
    });
  },
  
  showFeedback: function(){
    Presto.showTemplate('www/templates/feedback.hbs');
  },
  
  logoutUser: function() {
    var logoutUrl = "http://" + Presto.app.host + "/users/sign_out.json"
    console.debug("Sending DELETE request to " + logoutUrl);
    $.ajax(logoutUrl, {
      type: 'POST',
      data: {"_method": "delete"},
      success: function(responseData, status, xhr) {
        console.debug("User logged out");
        Presto.resetOrder();
        Presto.resetUserData();
        Presto.populateSidebarView();
      },
      error: function(responseData, status, xhr) {
        console.debug("Logging out failed with status : " + status);
        console.debug("Response = " + JSON.stringify(responseData));
        Presto.resetOrder();
        Presto.resetUserData();
        Presto.fetchAndUpdateUserData();
      }
    });
  },
  
  fetchAndShowHomePageOffer: function(hasOfferCallback){
    if(Presto.merchant.has_home_page_offer){
      var homePageOfferUrl = "http://" + Presto.app.host + Presto.merchant.home_page_offer_url;
      $.ajax(homePageOfferUrl, {
        type: 'GET',
        success: function(responseData, status, xhr) {
          if(responseData.offer_text && responseData.offer_text != ""){
            $("#splashOfferContent").html(responseData.offer_text);
          $(".splashOffer").removeClass("hidden");
      if(hasOfferCallback){
        hasOfferCallback(responseData);
      }      
          }
        },
        error: function(error, status, reason) {
        }
      });
    }
  },
  
  showQuickOrderScreen: function(event) {
    if (Presto.user.loginStatus) {
      /* User is logged in. Show the quick_checkout_logged_in.hbs screen */
      console.debug("Showing quick order page for logged in user");
      templateData = {
        user: Presto.user,
        order: Presto.user.order,
        outlet: Presto.merchant.outletsHash[Presto.merchant.catalog.outlet_id]
      };
      Presto.showTemplate('www/templates/quick_order_logged_in.hbs', templateData);
    } else {
      console.debug("Showing quick order page for logged out user");
      Presto.showTemplate('www/templates/quick_order_logged_out.hbs', Presto.user.order);
    }
  },
  
  
  showAlert: function(msg){
    $.blockUI(Presto.getAlertData(msg));
    $("#closeAlert").click(function(event){
      $.unblockUI();
    })
  },
  
  
  getAlertData: function(msg){
    return {message: '<p style="padding: 10px;">' + msg + '<br/><input id="closeAlert" type="button" value="ok"/><br/></p>', css: {position: 'fixed',top: '240px',left: 'auto',right: 'auto',margin: '0 10%',width: '80%',backgroundColor: '#111111',color: 'white','text-align': 'center','border-radius': '8px','font-size': '0.8em','font-weight': 'bold'}};
  },
  
  getThrobberData: function(msg){
     return {message: '<p style="padding: 10px;">' + msg + '<br><br><img src="images/throbber.gif" alt="throbber" width="32" height="32"></p>', css: {position: 'fixed',top: '240px',left: 'auto',right: 'auto',margin: '0 10%',width: '80%',backgroundColor: '#111111',color: 'white','text-align': 'center','border-radius': '8px','font-size': '0.8em','font-weight': 'bold'}};
  },
  
  showTemplate: function(templateName, data, noScroll) {
     if(Presto.merchant.has_home_page_offer){
    $(".splashOffer").addClass("hidden");
  }
    if(Presto.noTransaction && templateName != "www/templates/no_transaction.hbs"){
      var no_transaction_data = {
      "message": Presto.noTransactionMessage,
      "merchant": Presto.merchant
    }
      Presto.showTemplate('www/templates/no_transaction.hbs', no_transaction_data);
    return;
  }
    console.debug("Rendering template : " + templateName);
  $(".sidePanelCategory").removeClass("active");
    Presto.slidebars.close();
    var html_data = "<h3>Oops..! Something went wrong. Please close the app and try again. Sorry..!</h3>"
    try {
      if(Presto.merchant.show_menu_on_home && Presto.merchant.show_menu_on_home == "true" && templateName == "www/templates/home.hbs"){
        if(Presto.merchant.show_categories_in_bottom_bar && Presto.merchant.show_categories_in_bottom_bar == 'true'){
          Presto.showCatalog("category.hbs");
        }else {
          Presto.showCatalog("category_list.hbs");
        }        
        return;
      }else {
        html_data = Presto.templates[templateName](data);
      }
      
      console.debug("HTML data = \n" + html_data);
    } catch (e) {
      console.error("Caught exception : " + e.message);
      console.error("Stack : \n" + e.stack);
    }
  Presto.app.currentPage = templateName;
    $("#presto-main-view").html(html_data);
    if(!noScroll){
      //$(document).scrollTop(0);
    $("#sb-site").scrollTop(0);
    $("#presto-main-view-container").scrollTop(0);  
    $("#presto-main-view").scrollTop(0);  
    }
  $("#presto-main-view-container").css({"overflow-y": 'auto'});
    PrestoAnalytics.trackView(templateName.replace("www/templates/", ""));
  },
  
  showTemplateInSidebar: function(templateName, data) {
    console.debug("Rendering template : " + templateName + " in sidebar");
    var html_data = "<h3>Oops..! Something went wrong. Please close the app and try again. Sorry..!</h3>"
    try {
      html_data = Presto.templates[templateName](data);
      console.debug("HTML data = \n" + html_data);
    } catch (e) {
      console.error("Caught exception : " + e.message);
      console.error("Stack : \n" + e.stack);
    }
    $("#presto-sidebar-view").html(html_data);
  }
};
